/*
	Write by xempo 2013
	Free under LGPL
*/

#include "highlight.h"
#include "editor.h"

// Version 0.8 6|  03 2016

HighLighter :: HighLighter( Editor *ed, const StyleVal *color, const unsigned int *line_style, int Cnt, 
		const char ***ctype, const TxtStyle *cstyle,
		int sybcnt, const char **sybel) :
		QSyntaxHighlighter(ed),
		orgColor(ed->color().rgb()), edt(ed),
		colors(color), YHcolor(line_style[0]), BZcolor(line_style[1]), cppBZcolor(line_style[2]),
		styleCount(Cnt), orgline(-1),
		sybCount(sybcnt), sybs(sybel)
{
int i;
for(i=0; i<c_style_count+1; i++)c_type[i]=ctype[i];
for(i=0; i<c_style_count+1; i++)c_style[i]=cstyle+i;
edt->setHL(this);
}

bool HighLighter::isLine(char ch, int idx)
{
register int i;
for(i=0; i<sybCount; i++)
	if(sybs[i][idx]==ch)return true;
return false;
}

bool HighLighter::isBlock(const char *spt, int idx)
{
register int i;
for(i=0; i<sybCount; i++)
	if(*spt==sybs[i][idx] && spt[1]==sybs[i][idx+1])return true;
return false;
}

void HighLighter::_init()
{
	inputLine=CS_Init;
	paraBack=-1;
	fnt.setBold(false);
	fnt.setItalic(false);
	fnt.setUnderline(false);
	edt->setFont(fnt);
}

// HighLighter :: ~HighLighter(){}

int HighLighter::feelFormat(const char *pt, int p)
{
  if(pt==NULL)return 0;
  register int t=-1, sc=0; // 0 norm; 1 cppBZ ; 2 cBZ;  3 YH(" ");
  int R=-2, row=0;
  while( row!=p )
    switch( pt[++t] ){
    case 0 : goto _ex_; //return sc;
    case '\n' :
_jmp_:	row++;
	break;
    case '\"' :
	if( t<1||pt[t-1]!='\\'|| t>1&&pt[t-2]=='\\' )
	switch(sc){
	case SC_Norm : sc=SC_YH; // 3
		break;
	case SC_YH /* 3 */ : sc=SC_Norm;
	}
	break;
     default : 
	if(sc!=SC_YH){
	    if( t>0 && isBlock(pt+t-1, 4) ){
		sc=SC_Norm; break;
		}
	    if(isBlock(pt+t, 2)){
		sc=SC_BZ_c;	R=row;
		break;
		}
	    if(isLine(pt[t],0) && sc!=SC_BZ_c){
		while(pt[++t]!='\n'&&pt[t]);
		if(pt[t])goto _jmp_;
		else return sc;
		}
     	}
    }
_ex_: return (R>=row&&sc==SC_BZ_c&&edt->cs_feel()==true&&
	pt[t]!=0&&pt[t+1]!='\n'/* not emtpy line */) ? SC_Norm : sc;
}

enum endStateOfLastPara {
GoOn=15,
PasteSelect=14,
EndCommitFinish=13,
FirstYH=12,
EndCommit=11, //  =>  */ ....
FirstCommit=10 // => /* ....
}; 

#define recoverOrg() if(inputLine!=CS_Init&&org<Idx)setStyle(org, Idx-org, orgColor, false, false, false)

void HighLighter::setStyle(int s, int len, unsigned int c, bool bold, bool italic, bool underline)
{
fnt.setBold(bold);	fnt.setItalic(italic);
fnt.setUnderline(underline);
setFormat(s, len,  fnt, c);
}

inline bool memChr(const char *src, register const char chr, const int len)
{
int t;
for( t=0; t<len&&src[t]!=chr; t++);
return (t<len);
}

int HighLighter :: highlightParagraph( const QString &text, int paraState)
{
 if(edt->sel_feel())return PasteSelect; // delete selection when paste on hasSelected
 bool  Inputing, doPaste, BZ_SC_b=false, a_BZ_SC, isCS;
 int  S, i, cnt, P, P2,
	Idx=0, org=0,
	YHstat=0, YHpos=0,
	BZposb=0;
 const char *pt=(const char *)text;
#if QT_VERSION < 0x030300
 edt->getCursorPosition(&P, &i);
#else
 P=currentParagraph();
#endif

 if(inputLine!=CS_Init){
	P2=orgline; orgline=P; /*  del or bkspc to redure a line, would tagg mult ....*/
	}

 switch(edt->paste_feel()){
 case 1 : edt->setPasteFeel(2);
	Inputing=true; doPaste=true;
	break;
 case 2 : Inputing=false; doPaste=true;
	break;
 default : Inputing=(inputLine==CS_Modifying);
	doPaste=false;
 }
 a_BZ_SC=doPaste;
 if( Inputing ){
	paraState=0;	paraBack=-1;
	switch(feelFormat(edt->text(),  P )){
	case SC_BZ_c /* 2 */ : BZ_SC_b=true;
			break;
	case SC_YH /* 3 */ : YHstat=1;
			break;
	case SC_Norm/* 0 */ :
			if(edt->cs_feel() )a_BZ_SC=true;  //  delete     /* ...
			else if( edt->yh_feel() )inputLine=2;
		}
	if(edt->todoMsg && (BZ_SC_b||a_BZ_SC) )edt->update=true;
   }
  else {
       if(doPaste){
	switch(paraState){
	case EndCommitFinish :
		return EndCommitFinish; // fast
		// return 0; lower
	case FirstYH : YHstat=1;
		break;
	case EndCommit :  a_BZ_SC=true;
		break;
	case FirstCommit : BZ_SC_b=true;
	}
	paraState=0;
	}
          else {
	if(inputLine>0){
	   if(paraState==FirstYH){
		YHstat=1;
		paraState=0;
		}
	}
	else switch(paraState){
	        case EndCommitFinish :
		return EndCommitFinish; // fast
		// return 0; lower
	        case FirstYH : YHstat=1;
		break;
	        case EndCommit :  a_BZ_SC=true;
		break;
	        case FirstCommit : BZ_SC_b=true;
		break;
	        default :  /* LinesChange :  */
		if(paraBack==P) // Key_Return or Key_delete(lineEnd) or backspace(lineHead)
			return FirstCommit;
//		if(inputLine!=CS_Init)return 0; // delete a line, next send paraState==0 whether return any value
	}
        }
   }
   const  TxtStyle *txtstyle;
   const char *spt, *style, *bflm, *aflm, **ctype;
   int bf, af, SN;
   isCS=(styleCount>=c_style_count);
   while( pt[Idx] ){
	spt=pt+Idx;
	if(YHstat%2){
		if(isYH(pt,Idx))goto _jmp_YH_;
		else goto _skip2_;
	}
	if(BZ_SC_b==false && isLine(*spt,0) && isLine(spt[1],1) ){
		    for(i=2; spt[i]; i++);
		    setStyle(Idx,i,cppBZcolor, !isCS, isCS, false);
		    goto _out_;
		}
	if(isBlock(spt, 2)){
		recoverOrg();
		switch(paraState){
		case FirstCommit :  if(inputLine==CS_Init)goto _skip2_; // 2 condition
			setStyle(0,Idx+2,BZcolor, !isCS, isCS, false);
			break;
		case EndCommit :
			return inputLine!=CS_Init ? EndCommitFinish : 0;
		}
		if(BZ_SC_b==false){
			BZ_SC_b=true; BZposb=Idx++;
		}
	}
	else if(isBlock(spt, 4)){
		if(inputLine!=CS_Init)
			switch(paraState){
			case FirstCommit : 
				setStyle(0, (++Idx+1), BZcolor, !isCS, isCS, false);
				if(edt->undo_feel()||doPaste)goto _BZ_;
				return P2!=P ?  EndCommitFinish : EndCommit;
			case EndCommit :
				setStyle(0, (++Idx+1), orgColor, false, false, false);
				if(edt->undo_feel())goto _BZ_;
				return EndCommitFinish;			
			}
		if(BZ_SC_b){
		    recoverOrg();
		    setStyle(BZposb, (++Idx+1)-BZposb, BZcolor, !isCS, isCS, false);
		    if(Inputing)_BZ_ : a_BZ_SC=true;
		    org=Idx+1;		BZ_SC_b=false;
		    paraState=0;
		    goto _skip2_;
		}
	}

	if(BZ_SC_b==false&&isYH(pt, Idx)){
_jmp_YH_:	if((++YHstat)%2==0){
		    if(BZ_SC_b==false){
			recoverOrg();
			setStyle(YHpos, Idx-YHpos+1, YHcolor, false, false, false);
			org=Idx+1;
			}
		}
		else  YHpos=Idx;
	}
	if(BZ_SC_b||paraState==FirstCommit)goto _skip2_;

	SN=0;
_C_S_:	txtstyle=c_style[SN];
	ctype=c_type[SN];
	if(memChr(txtstyle->fast, *spt, txtstyle->fastlen)){
	    bflm=txtstyle->bflm;	aflm=txtstyle->aflm;
	    bf=txtstyle->bflen;	af=txtstyle->aflen;
	    for(S=0; S<txtstyle->cnt; S++){
		style=ctype[S];
		for(cnt=0; style[cnt]&&spt[cnt]==style[cnt]; cnt++) ;
		if(style[cnt]==0 && (Idx==0||memChr(bflm,spt[-1], bf)) && memChr(aflm, spt[cnt], af) ){
			if(SN<2 && isCS ){	i=Idx-1;
				for(cnt++; i>-1&&(pt[i]==32 ||pt[i]=='\t');  cnt++)i-- ;
				if(pt[i]!='#' ) goto _skip1_;
				Idx=i;
				if(SN==0){
				    while(--i>-1&&(pt[i]==32 || pt[i]=='\t'));
				    if(i>-1)goto _skp_;
				}
			}
			recoverOrg();
			setStyle(Idx, cnt, colors[SN].color, colors[SN].bold, colors[SN].italic, colors[SN].underline);
			_skp_: Idx+=cnt-1; org=Idx+1;
			goto _skip2_;
		}
	    }
	  }
	_skip1_: if(++SN<styleCount)goto _C_S_;
  _skip2_: Idx++;
  }
_out_:	if(inputLine==CS_Modifying)inputLine=0;
	else if(inputLine>0)inputLine--;

if( YHstat%2 ){
	i=Idx-1;
	while(i>YHpos &&(pt[i]==32 || pt[i]=='\t'))i--;
	if(pt[i]=='\\'){
		setStyle(YHpos, Idx-1-YHpos, YHcolor, false, false, false);
		return FirstYH;
	}
	if(org<=YHpos){
		setStyle(org, Idx-1-org, orgColor, false, false, false);
		return 0;
	}
}
if(BZ_SC_b){
	i=Idx-1-BZposb;
	setStyle(BZposb, i<BZposb ? BZposb : i,  BZcolor, !isCS, isCS, false);
	if(inputLine!=CS_Init)
		paraBack=P; // because : delete a line, and connect as /*
	return FirstCommit;
}

recoverOrg();
return ( a_BZ_SC ||paraState==EndCommit) ? EndCommit : (inputLine>0 ? GoOn : 0 );
}
