/*
	Write by LinJiangHua (xempo) 2010-2011
	Free under LGPL
*/

#include <dirent.h>
#include <utime.h>
#include <pthread.h>
#include <qclipboard.h>
#include <qapplication.h>
#include <qtoolbutton.h>
#include <qlistbox.h>
#include "filesan.h"
#include "xfun.h"
#include "proedit.h"
#include "../libnorm/browslist.h"
#include "../rtdata/en/target/filesor.h"
#include "shellcom.h"
#include "stocks.h"
#include "simpleimage.h"
#include "copypanel.h"
#include "searchmodify.h"

extern BrowsList brwList, curItemList;

int comD, inputH;

void Filesan::bwResize(BaseWidget *bw)
{
#define  ButtonWH  26
// int id=bw->winId();
if(bw==mainBW){
	int y, pw, hd, w=bw->width(), comH= inputH ? inputH : fontHeight*3/2;
	if(comH<ButtonWH)comH=ButtonWH;
	y=(comH-ButtonWH)/2;
	if(modul==NO_MULT_PANEL){
		if(_multPanelBtn==NULL){
			_multPanelBtn=creatPB(bw, multPanelImg, multPanelChs, this, slot_multPanel, true, false, Key_F9);
			_list=creatPB(bw, filelistImg, listChs, this, slot_list, true, _filelist);
			_browImg=creatPB(bw, grapBrowImg, browImageChs, this, slot_imgbrw, true, brwImg);
			_onlyFile=creatPB(bw, onlyFileImg, onlyFileChs, this, slot_onlyfile, true, pms_onlyFile);
			_multPanelBtn->show();
			_list->show();
			_browImg->show();
			_onlyFile->show();
		}
		hd=28;
		pw=w-(ButtonWH+2)*4-1-28;
		_multPanelBtn->setGeometry(1, y, ButtonWH, ButtonWH);
		_list->setGeometry(w-(ButtonWH+2)*3, y, ButtonWH, ButtonWH);
		_browImg->setGeometry(w-(ButtonWH+2)*2, y, ButtonWH, ButtonWH);
		_onlyFile->setGeometry(w-ButtonWH-2, y, ButtonWH, ButtonWH);
	}
	else {
		if(_multPanelBtn){
			delete _multPanelBtn;
			_multPanelBtn=NULL;
			delete _list;
			delete _browImg;
			delete _onlyFile;
		}
		hd=1;
		pw=w-1-2-ButtonWH;
	}
	pathComb->setGeometry(hd, 0, pw, comH);
	reFreshBtn->setGeometry(pw+1+hd, y, ButtonWH, ButtonWH);
	currentView()->setGeometry(0, comH+1, w-1, bw->height()-comH-2);
	if(inputH<ButtonWH){
		comD=pathComb->height() - pathComb->lineEdit()->height();
		inputH=fontHeight+fontDiv(4)+comD;
		}
}
else if(bw==dirBW)multPanelResize(dirBW);
}

void Filesan::MVCWD(char *dn, bool isComb)
{
const char *oldFilter;
if( divFileName(dn, &oldFilter) ){
	if(isComb){
		if(Filter)free((void *)Filter);
		Filter=oldFilter;
		}
	}
setCWD(dn, SHOW_LIST);
}

void Filesan::updateFophonix(bool isComb)
{
if(isComb)holdWait();
char *dn, *pt=strdup( pathComb->currentText().isEmpty() ? pcwd : (const char *)vStrCodec->fromUnicode(pathComb->currentText()) );
if(*pt=='~'&&(pt[1]=='/'||pt[1]==0)){
   if(pt[1])dn=catstr(home, pt+2, '/');
   else dn=strdup(home);
   free(pt);
}
else dn=pt;

if(isDirList(dn))treeview->seekDir(dn, SHOW_LIST|(isComb? COMBENTER:0));
else MVCWD(dn, isComb);

free(dn);
}

void Filesan::runFilesan(char *chs)
{
	char  *pt;
	struct stat64 st;
	if(stat64(chs,&st)==0&&S_ISDIR(st.st_mode)==0)
		if( (pt=strrchr(chs,'/')) )pt[0]=0;
	runStatus();
	Filesan *fs=new Filesan(NULL, init_rt);
	fs->exec(chs);
}

void Filesan::runStatus()
{
pms_listView=(_filelist!=NULL);
pms_sort=listview_sort;
pms_sort2=iconview_sort;
pms_ascend=sort_ascend;
pms_browImage=brwImg;
pms_showHide=showHide;
pms_multPanel=modul;
}

int Filesan::delFile(void *it, int isView, int id)
{
char *pt=isView<0 ? (char *)it :
	(isView ? itemFullPath(it) : (modul!=_FASTTAGS ? treeFullPath(((LVItem *)it)) : treeview->tagFullPath((LVItem *)it) ));
int rt;
if( isView==0 || (DelTag!=AllDel && cfg_warnDel==false) )
    switch(DelTag=infoWidget (pt, NULL, id, this)){
    case  NoDel :
    case  CancelDel :
    case  NO_BTN_ID : // click closeBox in title or Esc
	rt=2;	goto _jmp_;
    }
rt=_delFile(this, pt);
_jmp_: if(isView>-1)free((void *)pt);
return rt;
}

int Filesan::delIV(IVItem *ico, int val)
{
	int i=ico->index();
	if(ico->isDir())vDirCnt--;
	else vFileCnt--;
	if(ico_cnt>=ico_pre){
	  IVItem **tmp;
	  ico_pre+=16;
	  tmp=(IVItem **)malloc(ico_pre*sizeof(IVItem *));
	  if(ico_cnt>0){
		memcpy(tmp, deleteIcons, ico_cnt*sizeof(IVItem *));
		free(deleteIcons);
		}
	  deleteIcons=tmp;
	}
	deleteIcons[ico_cnt++]=ico;
	iconDel=val;
	_iconview->takeItem(ico);
	return i;
}

int Filesan::deleteIV(const char *nam)
{
IVItem  *ico=(IVItem *)_iconview->findItem(tranText(vStrCodec, nam),CaseSensitive|ExactMatch);
return ico ? delIV(ico) : -1;
}

void Filesan::delLVItem(LVItem *it, int val)
{
if(it_cnt>=it_pre){
	it_pre+=16;
	LVItem **tmp=(LVItem **)malloc(it_pre*sizeof(LVItem *));
	if(it_cnt>0){
		memcpy(tmp, deleteItems, it_cnt*sizeof(LVItem *));
		free(deleteItems);
		}
	deleteItems=tmp;
	}
deleteItems[it_cnt++]=it;
itemDel=val;
}

int Filesan::delLV(LVItem *it, int val)
{
 int i=listViewIndex(_filelist, it);
 if(i>-1){
	if(it->isDir())vDirCnt--;
	else vFileCnt--;
	delLVItem(it, val);
	_filelist->takeItem(it);
	}
 return i;
}

int Filesan::deleteLV(const char *nam)
{
LVItem *it=(LVItem *)_filelist->findItem(tranText(vStrCodec, nam),0);
return it ? delLV(it) : -1;
}

void Filesan::setCopyStats(const char *chs)
{
int i, n=0;
QApplication::clipboard()->setText(_toUnicode(chs), QClipboard::Clipboard);
for(i=0; i<filesors.count(); i++)n=filesors.at(i)->PreCopyStats(n);
}

void Filesan::changButton(QAction *btn, const char *chs, int c, bool B)
{
 char txt[200];
 btn->setEnabled(B);
 if(B)sprintf(txt, c>1? operaCounts : operaCount, chs, c);
 btn->setMenuText(QString::fromUtf8(B ? (const char *)txt :  chs) );
}

int Filesan::PreCopyStats(int c)
{
int i, mv=0;
bool b;
char *fn, *sf, *pt;
if(c<1)c=selAsSrc.memDiv("\n");
b=(CurDirMode&mode_x) && (CurDirMode&mode_w)&& c>0; //&& selectedEnabled;
changButton(copyAct, copyChs, c, b);
if(srcType)b=false; /* id cp file*/
if(b){
    int L=strlen(dirNam);
    for(i=0; i<c; i++){
	sf=selAsSrc.lstIndex(i);
	pt=strrchr(sf,'/');
	if( strstr(sf, dirNam)!=sf || sf+L != pt ) mv++;
	}
}
changButton(fdupAct, dupChs, c, b);
changButton(moveAct, fmove, mv, mv&&b);
changButton(sylnkAct, creatSymChs, c, b);
operaSrcMenu->setItemEnabled(linkId, b);

changButton(genArchAct, compressChs, c, b);
arEng->setEnabled(b);
ORLarEng->setEnabled(b);
//operaSrcMenu->setItemEnabled(arEngId,b);

changButton(ORLarchAct, ORLarChs, c, b);
// operaSrcMenu->setItemEnabled(ORLarEngId, b);

if(b)for(i=0; i<c; i++)
	if(namefilters(selAsSrc.lstIndex(i), archNam, 1)==0){
		b=false; break;
		}
operaSrcMenu->setItemEnabled(dcmpId, b);
return c;
}

void Filesan::setFSInfo( )
{
char tmp[80];
sprintf(tmp, statFmt, vDirCnt+vFileCnt, vDirCnt, vFileCnt);
statLab->setText(QString::fromUtf8(tmp));
}

typedef struct {
Filesan *fs;
FastBlock *file_lst;
ListOptions *f_mode;
const char *pth;
}ProcImg;

typedef struct {
void *it;
QImage *img;
const QPixmap *pix;
}ImageSet;

void *thrProcImg(void *pt)
{
ProcImg *pms=(ProcImg *)pt;
pms->fs->processImage(pms->pth, pms->file_lst, pms->f_mode);
free((void *)pms->pth);
free(pms);
return NULL;
}

void Filesan::leavePlace()
{
placeBtn->setOn(false);
bPanel->showMsg(NULL);
}

void Filesan::holdWait()
{// use for  exit prog
if(runImg){
	thrImg=false;
	while(runImg)__sleep(200);
	__sleep(200); // safe
	}
if(notifying){
	notifyMsg=false;
	while(notifying)__sleep(200);
	__sleep(200);
}
}

inline void Filesan::processImage(const char *pth, FastBlock *file_lst, ListOptions *mode)
{
  char *filename;
  int i, gRt;
  QImage *img;
  ImageSet *set;
  runImg=true;
  for(i=0; i<file_lst->count()&&thrImg; i++)if(mode[i].isImg){
	set=(ImageSet *)zalloc(sizeof(ImageSet));
	img=new QImage;
	filename=catstr(pth, file_lst->lstIndex(i), '/');
	if(_filelist){
		if( (gRt=setItemImage(filename, cfg_dbSiz ? 48:24, img, NULL))!=-2 ){
			delete img;
			set->pix=gRt<0 ? freqPix[mode[i].icon] : ((LVItem *)pIcon[gRt])->pixmap(0);
		}
		else goto _setImg_;
	}
	else {
		if( (gRt=setItemImage(filename, cfg_dbSiz ? 256 : 128, img, NULL))!=-2){
			delete img;
			set->pix=gRt<0 ? freqPix[ICO_SEPA+mode[i].icon] : ((IVItem *)pIcon[gRt])->pixmap();
		}
		else {
	_setImg_:	pIcon[idxIcon++]=mode[i].item;
			set->img=img;
		}
	}
	free(filename);
	if(thrImg){
		set->it=mode[i].item;
		appPost(_filelist ? 65017 : 65018, set, this);
	}
	else { free(set); delete img; }
  }
  runImg=false;
  QApplication::postEvent(this, new CustEvents(65020));
}

#define  isDirNotify()  (dirname==NULL)
void Filesan::freshView(const char *dirname, bool eXe,
	FastBlock *dir_lst, ListOptions *d_mode,
	FastBlock  *file_lst, ListOptions *f_mode)
{
  LVItem *it=NULL;
  IVItem  *ico=NULL;
  int tms, idx, cols, t, i, b, Sort, cn, rt, N, waitImg;
  bool Case=(bool)pms_case;
  char **lst, *tmp;
  ListOptions *mode, opt, *pO;
  FastBlock *mlst;
  dir_lst->memDiv(NULL); // must here, as notify..
  file_lst->memDiv(NULL);
  if(_filelist){
	Sort=eXe ? listview_sort-1 : 0;
	cols=_filelist->columns();
	if(Sort>0)Sort=useCols[Sort-1];
	}
  else   Sort=eXe ? iconview_sort-1 : 0;
  focusIt=NULL;
  focusIco=NULL;
  vispos=-1;
  waitImg = cfg_dbSiz ? imgWait+ICO_SEPA : imgWait;
  for(tms=0, mlst=dir_lst, mode=d_mode; tms<2 ; tms++, mlst=file_lst, mode=f_mode ){
    if(dirname && pms_onlyFile && tms==0)continue;
    cn=mlst->count();
    lst=mlst->plist();
    for(i=0; i<cn; i++){
	if(Sort<0)goto pms_sort_end_;
	idx=i;
	for( t=idx+1; t<cn; t++)
	 switch(Sort){
	 case 0 :_namcmp_: if( (namcmp(lst[idx], lst[t],Case)>0) == sort_ascend )idx=t;
		break;
	 case 1 : if(mode[idx].siz==mode[t].siz)goto _namcmp_; // 次排庄1\A47
		else if( (mode[idx].siz>mode[t].siz)== sort_ascend)idx=t;
		break;
	 case 2 : if(mode[idx].mtm==mode[t].mtm)goto _namcmp_;
		else if((mode[idx].mtm>mode[t].mtm)== sort_ascend)idx=t;
		break;
	 case 3 : if(mode[idx].atm==mode[t].atm)goto _namcmp_;
		else if((mode[idx].atm>mode[t].atm)== sort_ascend)idx=t;
		break;
	 case 4 : rt=namcmp(mode[idx].uName, mode[t].uName, Case);
		if(rt==0)goto _namcmp_;
		else if( (rt>0) == sort_ascend )idx=t;
		break;
	 case 5 : rt=namcmp(mode[idx].gName, mode[t].gName, Case);
		if(rt==0)goto _namcmp_;
		else if( (rt>0) == sort_ascend )idx=t;
		break;
	 case 6 : if(mode[idx].mode==mode[t].mode)goto _namcmp_;
		else if((mode[idx].mode>mode[t].mode)== sort_ascend)idx=t;
		break;
	 case 7 : rt=namcmp(mode[idx].type, mode[t].type, Case);
		if(rt==0)goto _namcmp_;
		else if( (rt>0) == sort_ascend )idx=t;
		}
	if(idx!=i){
	  tmp=lst[idx];
	  lst[idx]=lst[i];
	  lst[i]=tmp;
	  opt=mode[idx];
	  mode[idx]=mode[i];
	  mode[i]=opt;
	}
pms_sort_end_: if(isDirNotify())continue;
	pO=mode+i;
	if(navBtn&&vispos==-1&&strcmp(lst[i], curItemTxt)==0)vispos=i;
	N=pO->icon;
	if(_filelist){
		it=new LVItem(_filelist, it, lst[i], NULL, tms==0);
		if(tms==0)it->setPixmap(0, *freqPix[N]);
		else if(pO->isImg){
			pO->item=it;
			thrImg=true;
			}
			else it->setPixmap(0, *freqPix[N]);
		if(eXe){
			if(N!=ICO_NOREAD && N!=ICO_NOREAD+DIR_OFF)it->setRenameEnabled(0,true);
			FileStat(pO, useCols, it, p_dtfmt, 1);
		}
		else for(b=1; b<cols; b++)it->setText(b, " ??? " );
		if(vispos>-1){ focusIt=it; vispos=-2; }
	}
	else {
		ico=new IVItem( _iconview, ico, lst[i], tms==0, N!=ICO_NOWRITE && N!=ICO_NOEXEC/*  only dir */);
		if(tms==0)ico->setPixmap(*freqPix[N+ICO_SEPA]); // (N<DIR_OFF ? N+DIR_OFF : N)+ICO_SEPA
		else if(pO->isImg){
			pO->item=ico;
			thrImg=true;
			ico->setPixmap(*freqPix[waitImg]);
			}
			else ico->setPixmap(*freqPix[ICO_SEPA+N]);
		if(eXe&&(N!= ICO_NOREAD && N!=ICO_NOREAD+DIR_OFF))ico->setRenameEnabled(true);
		if(vispos>-1){ focusIco=ico; vispos=-2; } 
		}
	}
  }
if(dirname){
  if(thrImg){
	ProcImg *imgpms=(ProcImg *)malloc(sizeof(ProcImg));
	imgpms->fs=this;
	imgpms->file_lst=file_lst;
	imgpms->f_mode=f_mode;
	imgpms->pth=dirname;
	doThread(PTHREAD_STACK_MIN+360*sizeof(char *), _IdlePriority, thrProcImg, imgpms);
  }
  else {
	free((void *)dirname);
	appPost(65020, NULL, this);
	}
  logNam.resetMem(NULL);

  if(_filelist){
	if(vispos!=-2)focusIt=(LVItem *)_filelist->firstChild();
	if(focusIt){
		_filelist->setCurrentItem(focusIt);
		focusIt->setSelected(true);
		}
  }
  else {
	if(vispos!=-2)focusIco=(IVItem *)_iconview->firstItem();
	if(focusIco){
		_iconview->setCurrentItem(focusIco);
		focusIco->setSelected(true);
	}
  }
  procSelects();
  PreCopyStats();
  normalCursor();
  fsStartTimer();
}

}

void Filesan::subDirs(const char *dn, LVItem *dirIt, int msg)
{
  const char *pth=catstr(dn, dirIt->fnam, '/');
  switch(setCWD(pth, msg, dirIt)){
  case lost_Link :
  case none_File : delete dirIt;
  }
  free((void *)pth);
}

void Filesan::createTree(const char *dirnam, FastBlock *dir_lst, ListOptions *d_mode, int msg, LVItem *pIt)
{
LVItem *child=(LVItem *)pIt->firstChild(), *it1, *it2, *bak=NULL;
bool  newTag, hasDir=(child!=NULL);
if(hasDir==false&&msg==FRESH_SUB_TREE)return;
busiedCursor();
ListOptions opt;
int idx, i, tSort=pms_treeDescend, // -1, 0, 1
dircnt =dir_lst->memDiv(NULL);
char *tmp, *pt, **Names=dir_lst->plist();
it1=child;
for(i=0; i<dircnt; i++)
   if(Names[i][0]!='.'){
     if(tSort){
	int t;
	idx=i;
	for( t=idx+1; t<dircnt; t++ )
	    if( Names[t][0]!='.' && (namcmp(Names[idx], Names[t], pms_case)>0) == (tSort>0) )idx=t;
	if(idx!=i){
	  tmp=Names[idx];
	  Names[idx]=Names[i];
	  Names[i]=tmp;
	  opt=d_mode[idx];
	  d_mode[idx]=d_mode[i];
	  d_mode[i]=opt;
	}
     } // end sort
     pt=Names[i];
     if(hasDir){
_re_cmp_: if(child==NULL)goto _newIt_;
	LVItem *item;
	it2=child;
	child=(LVItem *)child->nextSibling();
	if( strcmp(it2->fnam, pt) || it2->text(0)!=tranText(vStrCodec, pt) ){
		item=it2;
		while(item&&strcmp(item->fnam,pt))item=(LVItem *)item->nextSibling();
		if(item==NULL){
	_newIt_:	newTag=true;
			it1=bak;
			goto _new_;
		}
		else { delete it2; goto _re_cmp_; }
	}
	bak=it2;	it1=it2;
	if(msg==FRESH_VIEW||msg==FRESH_SUB_TREE)goto _new2_;
	}
      else {
_new_:	it1=new LVItem(pIt, it1, pt );
_new2_:	int N=d_mode[i].icon;
	it1->setPixmap(0, *freqPix[ N ] );
	if(N!=ICO_NOREAD&&N!=ICO_NOREAD+DIR_OFF)it1->setRenameEnabled(0, true);
	if(newTag){
		newTag=false;
		bak=it1;
		child=(LVItem *)it1->nextSibling();
		if(msg==SHOW_TREE_LIST)goto _sub_;
	}
	if(msg==SHOW_TREE_THR&&pIt&&pIt->isSelected()==false&&cfg_moreShow==false)goto _ex_; // 当最理想状实现时，便是此结束之时
      }
      if(msg==SHOW_SUB_TREE||msg==FRESH_SUB_TREE||msg==SUB_TREE_LIST)
	_sub_: subDirs(dirnam, it1, msg!=FRESH_SUB_TREE ? SHOW_TREE_THR : FRESH_SUB_TREE);
    } // end for

   if(hasDir)removeLeft(child);
_ex_:   free(d_mode);
   normalCursor();
}

typedef struct {
const char *dirnam;
FastBlock dir_lst;
ListOptions *d_opt;
int msg; 
LVItem *Parent;
}creatTree_params;

/*typedef struct {
unsigned long long siz;
time_t mtm;
int mode, uId, gId;
}cmpSize;*/

#define ListOptionCmp(a1, a2) memcmp(a1, a2, sizeof(long long)+2*sizeof(time_t)+sizeof(int)*3)
//(a1.siz==a2.siz && a1.mtm==a2.mtm && a1.mode==a2.mode && a1.uId==a2.uId && a1.gId==a2.gId)

void Filesan::viewRemove(const char *dnam, FastBlock *fvp_lst, ListOpera *fvp_lo, int i, int cnt_dir, bool isdir)
{
char *nam;
if(_filelist)delLV(_filelist->Index(cnt_dir+i), 0); // fvp_lst->lstIndex(i));
else delIV(_iconview->Index(cnt_dir+i), 0); // fvp_lst->lstIndex(i));
nam=catstr(dnam, fvp_lst->lstIndex(i), '/');
if((modul!=_OPENROSE&&modul!=NO_MULT_PANEL)&&isdir)
	treeview->testRemoveDir(nam);
free(nam);
fvp_lst->remove(i); // remove include sort(...), not rem(i)
fvp_lo->remove(i);
}

static const char root_chs[]="/";
int Filesan::setCWD(const char *dirnam, int Msg, LVItem *dir_vIt )
{
struct  stat64   src_st;
char *chs;
int L,  i,  isDir,  msg=ReadComm(Msg);
dragDel=false;
if( lstat64(dirnam, &src_st) ){
	i=none_File;
_err_proc_:statusBarMsg(bPanel, i!=lost_Link ? noneFile : lnkNone, dirnam, 0x902019);
	statusBarMsg(bPanel, noneFile, dirnam, 0x902019);
	if(msg==DIR_NOTIFY_TOG){
		if(notifyFP){
			fcntl(notifyFP->_fileno, F_NOTIFY, 0);
			fclose(notifyFP);
			notifyFP=NULL;
		}
		if(modul!=NO_MULT_PANEL){
			treeview->testRemoveDir(dirnam);
			chs=strrchr((char *)dirnam, '/');
			if(chs==dirnam)chs++;
			L=chs-dirnam;
			char buf[L+2];
			for(i=0; i<L; i++)buf[i]=dirnam[i];
			buf[i]=0;
			treeview->seekDir(buf, SHOW_TREE_LIST);
		}
	}
	return i;
}
bool  list_all=(msg==SHOW_TREE_LIST||msg==SUB_TREE_LIST ||msg== FRESH_VIEW),
	only_list=(msg==RESHOW_LIST || msg==SHOW_LIST),
	ignoreFile, _lnk=S_ISLNK( src_st.st_mode );

  if(_lnk &&  stat64(dirnam, &src_st)  ){
//	if(only_list || list_all)statusBarMsg(bPanel, lostLink, dirnam, 0x902019);
	i=lost_Link;
	goto _err_proc_;
	}
  if( isReadable(u_id, g_id, &src_st)==false ){
	if(only_list || list_all)infoWidget(dirnam, NULL, noRightOpera, this);
	if(msg==SHOW_TREE_LIST||msg==SUB_TREE_LIST|| msg==SHOW_LIST)updatePathComb( (char *)dirnam ); // select by treeview
	return no_Right;
	}
  const char *fnam, *pt;
  LVItem *item1;
  DIR *dir;
  bool setlist, eXec, lock, xTag, canWrite, HU;
  struct dirent *dire;
  eXec=isExecable(u_id, g_id, &src_st);
  switch(msg){
  case SHOW_LIST : 
  case SHOW_TREE_LIST :
  case SUB_TREE_LIST :
	if( navBtn!=2 && brwList.NotCur(dirnam) ){ // 1 is parentDir
		static const char nullfile[2]={ 5, 0 };
		curItemList.setIndex(brwList.index());
		brwList.add(dirnam);
		pt=currentItemPath();
		if(pt){
			curItemList.add(strrchr(pt, '/')+1);
			free((void *)pt);
		}
		else curItemList.add(nullfile);
	}
  case RESHOW_LIST :
  case FRESH_VIEW : 
	thrImg=false;
	statusBarMsg(bPanel, opening, dirnam, 0); // not int thread process X
	CurDirMode=operaState(&src_st);// Fophonix list
	if(dno_dir_lst.count()){
		dno_dir_lst.resetMem(NULL);
		dno_d_lo.clear();
		}
	if(dno_file_lst.count()){
		dno_file_lst.resetMem(NULL);
		dno_f_lo.clear();
		}

	if(_filelist){
		_filelist->clear();
		_filelist->header()->setSortIndicator( listview_sort-1, sort_ascend);
	}
	else _iconview->clear();
	fsels.resetMem(NULL);
	break;
   case DIR_NOTIFY_TOG : 
	if( (modul==_FASTTAGS && modul==_OSROOT)&& (item1=(LVItem *)treeview->currentItem())
		&& memcmp(&statbak, &src_st, sizeof(struct stat64)) ){
		if(_lnk )L=ICO_LINKOBJ;
		else {
			xTag=isExecable(u_id, g_id, &src_st);
			canWrite=xTag ? isWritable(u_id, g_id, &src_st) : false;
			if(xTag==false )L=ICO_NOEXEC;
			else if(!canWrite)L=ICO_NOWRITE;
			     else L=0;
		}
		item1->setPixmap(0, /*modul==_FASTTAGS ? *selectTagPix(L) : */*freqDPix(L) );
		statbak=src_st;
		}
	if(notifyMsg==false)return 0;
  }
  FastBlock *p_lst, file_lst(AppenAlone), dir_lst(AppenAlone);// dir_lst has DeGuei
  ListOpera  d_StatOpt, f_StatOpt;
  dir=opendir(dirnam);
  L=strlen(dirnam);
  chs=(char *)malloc(L+258);
  strcpy(chs, dirnam);
  if(chs[L-1]!='/')chs[L++]='/';  // as //root,  would error for home-icon when user is root
  if(!eXec){ lock=true;	isDir=0;	_lnk=false;  i=-1;	}
  ignoreFile=( msg== INIT_DIRVIEW ||msg==SHOW_TREE_THR||msg==SHOW_TREE_ORDER || msg== SHOW_SUB_TREE||msg==FRESH_SUB_TREE);
//  list_all=(msg==SHOW_TREE_LIST ||msg== FRESH_VIEW)     only_list=(msg==RESHOW_LIST || msg==SHOW_LIST)
  setlist=(msg==DIR_NOTIFY_TOG ||only_list ||list_all);
  struct desktop *dktop;
  struct stat64 stlnk, stat1;
  HU = ( strcmp(dirnam, homeUnder)==0 );
  p_lst= msg==DIR_NOTIFY_TOG ? &file_lst : &dno_file_lst;
  while( dire=readdir(dir) ){
    if(msg==DIR_NOTIFY_TOG && notifyMsg==false)goto _out_;
    fnam=dire->d_name;
    if( ! (fnam[0]=='.' && (fnam[1]==0 ||( fnam[1]=='.'&&fnam[2]==0))) ){
	if( fnam[0]=='.' && !showHide /*||!(_lnk=(dire->d_type==DT_LNK)) && dire->d_type!=DT_DIR && ignoreFile*/ )
		continue; // fast, but reiserfs d_type=0 !! so no use above DT_...
	strcpy(chs+L, fnam);
	if(eXec){
		if( i=stat64(chs, &stat1) ){
			isDir=0;
			i=lost_Link;
			}
		else {
			isDir = S_ISDIR(stat1.st_mode);
			if((lock=!isReadable(u_id, g_id, &stat1))==false){
				xTag=isExecable(u_id, g_id, &stat1);
				if(isDir&&xTag)canWrite=isWritable(u_id, g_id, &stat1);
			}
		}
		lstat64(chs, &stlnk); // dire->d_type==DT_LNK, for reiserfs, d_type=0, so no use it		
		_lnk=S_ISLNK(stlnk.st_mode);
	} // eXec

      if( isDir ){
	dir_lst.add(fnam); // dir_lst would DeGuei, so only stacks, and copy(...)
	register int __m;
	if(HU&&msg<7&&strcmp(homeName,fnam)==0)__m=ICO_HOMEDIR;
	else if( lock )__m=ICO_NOREAD+DIR_OFF;
	        else if(_lnk )__m=ICO_LINKOBJ+DIR_OFF;
		else {
			if(xTag==false )__m=ICO_NOEXEC;
			else if(!canWrite)__m=ICO_NOWRITE;
				else __m=DIR_OFF;
			}
	d_StatOpt.preAdd(128, __m);
	if(setlist/* && _filelist*/)setListOption(d_StatOpt.last(), stat1, _lnk,
		lock ? no_Right : (i==lost_Link ? lost_Link : subDirCount(chs)) );
//	else if(d_StatOpt.count()>0&&msg==SHOW_TREE_THR
// &&dir_vIt&&dir_vIt->isSelected()==false )goto _out_;
     }
     else if(ignoreFile==false && namefilters(fnam,Filter, pms_flt_msg) ){
	p_lst->add(fnam);
	if(setlist){
	  register int __m;
	  if(i!=lost_Link){
		if( lock )__m=ICO_NOREAD;
		else if(memstr(fnam, 0, ".ora", 4, 1))__m=ICO_ORL_AR;
			else if(namefilters(fnam, archNam, 1))__m=ICO_ARCH;
				else if(_lnk)__m=ICO_LINKOBJ;
				        else if(xTag )__m=ICO_EXEC_FILE;
					else __m=0;
	  }
	  else __m=ICO_LINKNONE;
	  
	  f_StatOpt.preAdd(256, __m);
	  if( !is_dev(stat1.st_mode) // f_StatOpt.last()->isDev=true;
			&& eXec && brwImg && QImage::imageFormat(QString::fromLocal8Bit(chs)) )f_StatOpt.last()->isImg=true;
	  setListOption( f_StatOpt.last(), i==lost_Link&&_lnk ? stlnk : stat1, _lnk, i );
	}
         }
      }
  }
_out_:   free(chs);
  closedir(dir);
  ListOptions *_opt;
  switch( msg ){
  case DIR_NOTIFY_TOG : {
#define  notify_add  1
#define  notify_del  4
#define  notify_attr  32
	IVItem *ico;
	bool sel, notClear=true, listDir=!(bool)pms_onlyFile;
	int sz, nf_cnt, j, f, d0, chMsg=0;
	char *nam, *_pt;
	FastBlock *fvp_namlst, *vdlst;
	void *_ptr;
	ListOpera *fvp_stats, *plst_stats;
	ListOptions *fvp_opt;
	if(_filelist){
		disconnect(_filelist, sig_chsel, this, slot_chsel);
		disconnect(_filelist, sig_lCurCh, this, slot_lCurCh);
		}
	else {
		disconnect(_iconview, sig_chsel, this, slot_chsel);
		disconnect(_iconview, sig_iCurCh, this, slot_iCurCh);
		}
	if(notifyMsg==false)goto _jmp2_;
	freshView(NULL, eXec, &dir_lst, d_StatOpt.first(), &file_lst, f_StatOpt.first()); // get opts
	p_lst=&dir_lst;
	fvp_namlst=&dno_dir_lst;	vdlst=fvp_namlst;
	plst_stats=&d_StatOpt;
	fvp_stats=&dno_d_lo;
	sz=brwImg ? (_filelist ? 24 : 128) : -1;
	for(L=0; L<2; L++,
		p_lst=&file_lst, fvp_namlst=&dno_file_lst, 
		plst_stats=&f_StatOpt, fvp_stats=&dno_f_lo ){
	  if(listDir==false&&L==0)continue;
	  if(notifyMsg==false)goto _jmp2_;
	  _opt=plst_stats->first();
	  nf_cnt=p_lst->count();
	  i=0;
	  while( i<nf_cnt ){
		if(i >= fvp_namlst->count()){
		    if(_filelist){
			if(L==1)	_ptr=_filelist->lastItem();
			else _ptr=vdlst->count()>0 ? _filelist->Index(vdlst->count()-1) : NULL;
			}
		    else {
			if(L==1)	_ptr=_iconview->lastItem();
			else _ptr=vdlst->count()>0 ? _iconview->Index(vdlst->count()-1) :NULL;
			} // _iconview
		goto _skip_;
		}
#define  pfn p_lst->lstIndex(i)
		if(strcmp(pfn, fvp_namlst->lstIndex(i))){ // no same
			for(j=i+1; j<nf_cnt/*p_lst->count()*/; j++)
			     if(strcmp(p_lst->lstIndex(j), fvp_namlst->lstIndex(i))==0){ // qWarning("%s is update",fvp_namlst->lstIndex(i));
				for(f=i+1; f<fvp_namlst->count(); f++)
				    if(strcmp(pfn, fvp_namlst->lstIndex(f))==0){ // qWarning("i=%d,  j=%d %s moved", i, j, fvp_namlst->lstIndex(j));
					if(ListOptionCmp(/*fvp_opt*/fvp_stats->first()+i, _opt+j)==0){
						viewRemove(dirnam, fvp_namlst, fvp_stats, f, L&&listDir ? vdlst->count() : 0, L==0);
						chMsg|=notify_del;
						break;
					}
					goto _contin_;
				    } // pos change, as time-sort and file be mdf.
				if(_filelist){
					if(i==0 && (L<1 || vdlst->count()<1 ) )_ptr=NULL;
					else _ptr=_filelist->Index((L&&listDir ? vdlst->count()+i : i)-1);
					}
				else  {
					if(i==0 && (L<1 || vdlst->count()<1 ) )_ptr=NULL;
					else _ptr=_iconview->Index((L&&listDir ? vdlst->count()+i : i)-1);
					}
			_skip_:	nam=catstr(dirnam, pfn, '/');
				if(notClear){
					notClear=false;
					if(_filelist)_filelist->clearSelection();
					else _iconview->clearSelection();
				}
				_ptr=vInsertItem(_filelist ? _filelist : (QScrollView *)_iconview, nam, View_Add, sz, useCols, p_dtfmt, _opt+i, _ptr);
				if(L==0&&(modul!=_OPENROSE&&modul!=NO_MULT_PANEL))	treeview->newDirItem(nam, freqPix[ _opt[i].icon ], 0);
				if(newMsg){ newMsg=false; oldName=nam;
					if(_filelist)((LVItem *)_ptr)->startRename(0);
					else ((IVItem *)_ptr)->rename();
					}
				else free(nam);
				if(fvp_namlst->count()>0){
					fvp_namlst->insert(pfn, i);
					fvp_stats->insert(_opt+i, i );
					}
				else {
					fvp_namlst->add(pfn);	fvp_namlst->memDiv(NULL);
					fvp_stats->add(_opt+i, 12);
					}
				chMsg|=notify_add;
				goto _nx_;
			} // update fvp_namlst->lstIndex(i)
			// end for;  fvp_namlst->lstIndex(i) be delete
	_contin_:	viewRemove(dirnam,fvp_namlst, fvp_stats, i, L&&listDir ? vdlst->count() : 0, L==0);
			chMsg|=notify_del;
			continue;
		} // no same
	_nx_: i++;
	}
	while(i<fvp_namlst->count()){
		viewRemove(dirnam, fvp_namlst, fvp_stats, i, L&&listDir ? vdlst->count() : 0, L==0);
		chMsg|=notify_del;
		}
	fvp_opt=fvp_stats->first();
	for(i=0; i<nf_cnt && i<fvp_stats->count() && notifyMsg; i++)
		if(_opt[i].isLnk!=fvp_opt[i].isLnk || ListOptionCmp(_opt+i, fvp_opt+i) ){
			d0=L&&listDir ? vdlst->count()+i : i;
			fvp_opt[i]=_opt[i];
			if(_filelist){
				item1=_filelist->Index(d0);
				nam=catstr(dirnam, item1->fnam, '/');
				_ptr=item1;
//				_filelist->setCurrentItem(item1);
				}
			else {
				ico=_iconview->Index(d0);
				nam=catstr(dirnam, ico->fnam, '/');
				_ptr=ico;
//				_iconview->setCurrentItem(ico);
				}
			vInsertItem(_filelist ? (QScrollView *)_filelist : _iconview, nam, Opts_Chang, sz, useCols, p_dtfmt, _opt+i, _ptr);
			if(L==0&& (modul!=_OPENROSE&&modul!=NO_MULT_PANEL) ){
				item1=treeview->seekDir(nam, TEST_GETITEM );
				if(item1)item1->setPixmap(0, *freqPix[_opt[i].icon] );
			}
			chMsg|=notify_attr;
			free(nam);
		}
	}

_jmp2_:	vDirCnt=dir_lst.count();
	vFileCnt=file_lst.count();
	sel = vFileCnt+vDirCnt && (chMsg&notify_del);
	if(_filelist){
		connect(_filelist, sig_chsel, this, slot_chsel);
		connect(_filelist, sig_lCurCh, this, slot_lCurCh);
		}
	else {
		connect(_iconview, sig_iCurCh, this, slot_iCurCh);
		connect(_iconview, sig_chsel, this, slot_chsel);
		}

	if(chMsg&(notify_add|notify_del) )setFSInfo();
	if(chMsg)// objsUpdate();
		procSelects();
	if(sel && fsels.count()==0){
		if(_filelist)_filelist->setSelected(_filelist->currentItem(), true);
		else _iconview->setSelected(_iconview->currentItem(), true);
		}
	}
_ex_notify:	notifyMsg=false;	notifying=false;
	break;
  case SHOW_TREE_LIST : 
  case SUB_TREE_LIST :
  case SHOW_LIST : updatePathComb( (char *)dirnam ); // select by treeview
  case RESHOW_LIST :
  case FRESH_VIEW :	{ 
	bool creat = only_list==false && dir_vIt /*&& dir_vIt->childCount() == 0*/;
	statbak=src_st;
	vFileCnt=f_StatOpt.count();	vDirCnt=d_StatOpt.count();
	dno_dir_lst.copy(dir_lst);
	if( vDirCnt > 0 ){
		if(creat){
		  _opt=(ListOptions *)malloc(vDirCnt*sizeof(ListOptions));
		  memcpy(_opt, d_StatOpt.first(), vDirCnt*sizeof(ListOptions));
		}
		dno_d_lo=d_StatOpt;
		d_StatOpt.setZore();
	}
	if( vFileCnt>0 ){
		dno_f_lo=f_StatOpt;
		f_StatOpt.setZore();
		}

	fsKillTimer();
	setFSInfo();
	busiedCursor();
	idxIcon=0;
	if(pIcon)free(pIcon);
	pIcon = (vFileCnt&& brwImg) ? (void **)malloc( sizeof(void *) * vFileCnt ) : NULL;
	freshView(strdup(dirnam), eXec, &dno_dir_lst, dno_d_lo.first(),
		&dno_file_lst, dno_f_lo.first());
	if(msg==SHOW_LIST)return 0;
	if( creat&&vDirCnt )goto _creat_tree_item_;
	else if(vDirCnt==0)goto _clearItem_;
	}
	break;
  case INIT_DIRVIEW : 
	dir_vIt=new LVItem( treeview, root_chs);
	i=filePixmap(root_chs);
	dir_vIt->setPixmap(0, *freqDPix(i) );
//	dir_vIt->setOpen(true);
  case SHOW_TREE_ORDER :
  case SHOW_TREE_THR :
  case FRESH_SUB_TREE :
  case SHOW_SUB_TREE :
 	if( d_StatOpt.count()>0 ){
	  _opt=d_StatOpt.first();		d_StatOpt.setZore();
	  if(msg!=SHOW_TREE_THR)createTree(dirnam, &dir_lst, _opt, msg, dir_vIt);
	  else {
 _creat_tree_item_ : creatTree_params *pms=(creatTree_params *)zalloc(sizeof(creatTree_params));
	    pms->d_opt=_opt;
	    pms->dirnam=strdup(dirnam);	pms->dir_lst.copy(dir_lst);
	    pms->msg=msg;		pms->Parent=dir_vIt;
	    appPost(65003, pms, this);
	  }
	}
	else _clearItem_: while(dir_vIt&&dir_vIt->childCount())
				treeview->treeDel((LVItem *)dir_vIt->firstChild());
 }
 return 0;
}

inline void Filesan::setNotifyTimer(siginfo_t *siginfo)
{
	if(notifyFP->_fileno==siginfo->si_fd && notifyTimer->isActive()==false ){
		notifyTM=0;
		notifyTimer->start(30);
	}
}

void toggleChange(int sig, siginfo_t *siginfo, void *context)
{
int i;
for(i=0; i<filesors.count(); i++)filesors.at(i)->setNotifyTimer(siginfo);
}

void Filesan::closeNotify()
{
if(notifyFP){
	fcntl(notifyFP->_fileno, F_NOTIFY, 0);
	fclose(notifyFP);
	notifyFP=NULL;
}
}

void Filesan::dirNotify(const char *dnam)
{/* dirNotify setup*/
closeNotify();
if( (notifyDisk=isMount(dnam)) ){
	notifyFP=NULL;
	notifyTM=0;
}
else {
  notifyFP=fopen(dnam, "r");
  if(notifyFP){
	struct sigaction act;
	sigaction(SIGRTMIN+1, NULL, &act);
	act.sa_sigaction=toggleChange;
	act.sa_flags=SA_SIGINFO;
	sigemptyset(&act.sa_mask);
	sigaction(SIGRTMIN+1, &act, NULL);
	fcntl(notifyFP->_fileno, F_NOTIFY, DN_CREATE |DN_DELETE |DN_MODIFY| DN_RENAME |DN_ATTRIB| DN_MULTISHOT);
	fcntl(notifyFP->_fileno, F_SETSIG, SIGRTMIN+1);
  }
}
}

void Filesan::updatePathComb(char *dirnam)
{
 char *pt=dirNam;
 int sm;
 fmtinp(dirnam+1, NULL, root_chs, '/');
 if(*dirnam!=ROOT_CH){
	free(dirNam);
	pt=catstr(pcwd, dirnam, dirnam[0]? ROOT_CH:0);
	}
 else if(dirNam!=dirnam){
	free(dirNam);
	pt=strdup(dirnam);
	}
 dirNotify(pt);
 dirNam=pt;
 if(Filter)pt=catstr( pt, Filter, ROOT_CH);
 pathComb->setCurrentText( tranText(vStrCodec,pt) );
 pathcomb.add(pt);
 QListBoxItem *it;
 QListBox *lb=pathComb->listBox();
 if( lb&&(it=lb->findItem(pt,  ExactMatch|CaseSensitive)) )delete it;
 pathComb->insertItem(*pixmapLoad(combdirImg), tranText(vStrCodec,pt), 0);
 if(pt!=dirNam)free(pt);
 backDirAct->setEnabled(brwList.index()>0);
 nextDirAct->setEnabled(brwList.forwardabled());
 homeAct->setEnabled(strcmp(home, dirNam));
 pathList.argv[0]=dirNam;
 parentDirAct->setEnabled( dirNam[1] );
 sm=search_mdf_wdg ? search_mdf_wdg->getSmThread() : 1;
 if( (sm<1||sm>2) )
	search_mdf_wdg->getPathCombo()->setCurrentText(tranText(vStrCodec,dirNam));
}

void Filesan::updateDrivers()
{
	disktime=0;
	if(u_id==0)doMount(&pdklst);
	else {
		FastBlock tmp;
		getMount(&pdklst, tmp);
	}
	treeview->updateParts();
}

extern char *addlst(const char *fn);

const char oraEng[3][8]={ "--bzip2", "--gzip", "--lzma" };
static const char ar_eng[arCnt][6]={ ".bz2", ".gz", ".lzma", ".zip" };
void Filesan::customEvent(QCustomEvent *e)
{
int sw, i;
switch( (sw=e->type()) ){
case 65000 : 
	notifyMsg=true;	notifying=true;
	setCWD(dirNam, DIR_NOTIFY_TOG);
	notifyTM=cp_tm ? 3 : 0;
	disktime=0;
	return;
case 65001 : {
	struct dirpost_params *pms=(struct dirpost_params *)e->data();
	treeview->newDirItem(pms->dnam, pms->pix, pms->est);
	free((void *)pms->dnam);
	free(pms);
	}
	return;
case 65002 : {
	FinaStocks *stocks1=(FinaStocks *)e->data();
	if(stocks1->close())
	  while( (stocks1=stocksList.at(0)) )if(stocks1->close()==false)break;
	}
	return;
case 65003 : {
	creatTree_params *pms=(creatTree_params *)e->data();
	createTree(pms->dirnam, &pms->dir_lst, pms->d_opt, pms->msg, pms->Parent);
	free((void *)pms->dirnam);
	delete pms; // also do delete pms->dir_lst;
	}
	return;
case ErrorQ :
case CopyQuest : {
	struct infowdg_params *pms=(struct infowdg_params *)e->data();
	pms->ret=infoWidget(pms->dst, pms->cap, pms->info_id, CopyQuest && panelStatus==1 ? (QWidget *)cpThrPanel : this);
	pms->hold=false;
	}
	return;
case 65008 :{
	SimpleImage *grap1=(SimpleImage *)e->data();
	if(grap1->close())
	  while( (grap1=grapList.at(0)) )if(grap1->close()==false)break;
	}
	return;
case 65010 :
case 65011 : {
	ProEdit *pe=(ProEdit *)e->data();
	if(pe->close()){
		while( (pe=proEditList.at(0)) )if(pe->close()==false)return;
		}
	else return;
	if(sw==65011)QApplication::postEvent( qApp, new QCloseEvent );
	}
	return;
case 65013 : {
	unsigned int L;
	const uchar *pixbuf=(const uchar *)getImageData((const char *)e->data(), &L);
	free(e->data());
	if(pixbuf==NULL)return;
	QPixmap pix;
	if(pix.loadFromData(pixbuf, L)){
		char buff[60];
		sprintf(buff, "%dx%d%s", pix.width(), pix.height(), pix.hasAlpha() ? AlphChs : _Spc );
		bPanel->showMsg(buff, 129);
	}
	free((void *)pixbuf);
	}
	return;
case 65015 : updateDrivers();
	return;
case 65016 : treeview->createOpenRose(false);
	return;
case 65017 : {
	ImageSet *pms=(ImageSet *)e->data();
	LVItem *it=(LVItem *)pms->it;
	if(pms->img){
		if(thrImg)it->setPixmap(0,*pms->img);
		delete pms->img;
		}
	else if(thrImg)it->setPixmap(0,*pms->pix);
	free(pms);
	}
	return;
case 65018 : {
	ImageSet *pms=(ImageSet *)e->data();
	IVItem *ico=(IVItem *)pms->it;
	if(pms->img){
		if(thrImg)ico->setPixmap(*pms->img);
		delete pms->img;
		}
	else if(thrImg)ico->setPixmap(*pms->pix);
	free(pms);
	}
	return;
case 65020 : if(vispos==-2){
		if(_filelist)_filelist->ensureItemVisible(focusIt);
		else _iconview->ensureItemVisible(focusIco);
		}
	return;
case 65040 : _delFile(this, (const char *)e->data());
	free(e->data());
	return;
case 65086 :
case 65085 : {
	const char *fn, *fn2, *prg=NULL;
	char *cmd, *tmp,*cmds, *prg2, *chs;
	struct stat64 st;
	int j;
	FastBlock *fstblk = sw!=65086 ? &selAsSrc : &fsels;
	static const char darCmd[3][10]={"bzip2 -cd", "gzip -cd",  "lzma -cd" };
	while( i<fstblk->count() ){
		chs=fstblk->lstIndex(i);
		if(strstr(chs, ".tar"))prg="tar -xf";
		else if( (tmp=strstr(chs,".ar")) && strrchr(chs, '.')==tmp )prg="ar -x";
			else if( (tmp=strstr(chs,".ora")) && strrchr(chs, '.')==tmp ){
				fn2=addlst(chs);
				prg=catstr("release", fn2, 32);
				free((void *)fn2);
				fn2=addlst(dirNam);
				cmd=catstr(prg, fn2, 32);
				free((void *)fn2);
				free((void *)prg);
				comRun(NULL, cmd, 0, NULL);
				free(cmd);
				goto _conti_;
				}
		if(prg){
	_run_:		chdir(dirNam);
			fn2=addlst(chs);	
			cmd=catstr(prg, fn2, 32);
			free((void *)fn2);
			system( cmd );
			free(cmd);
			chdir(pcwd);
			goto _conti_;
			}
		else for(j=0; j<3; j++) if( (tmp=strstr(chs, ar_eng[j])) && strrchr(chs, '.')==tmp){
			fn=addlst(chs);
			cmd=catstr(darCmd[j], fn, 32);
			free((void *)fn);
			cmds=catstr(cmd, ">", 32);
			free(cmd);
			fn2=catstr(dirNam, strrchr(chs, '/'), 0);
			tmp=(char *)strrchr(fn2, '.');
			*tmp=0;
			if(stat64(fn2, &st)==0){
				if(isWritable(u_id, g_id, &st)){
					if(infoWidget(fn2, NULL, decmpOverId, this))goto _jmp3_;
				}
				else {
					infoWidget(fn2, NULL, decmpNoWriId, this);
			_jmp3_:		free((void *)fn2);free(cmds);
				goto _endcmpr_;
				}
			}
			prg2=addlst(fn2);
			free((void *)fn2);
			cmd=catstr(cmds, prg2, 32);
			free((void *)prg2);	free(cmds);
			system( cmd );
			free(cmd);
			goto _conti_;
			}
		prg="unzip";	goto _run_;
	_conti_ : i++;
	}
	goto _endcmpr_;
	}
    case 65094 :
    case 65093 : // cur
	if(isViewOpera()==false)fsels.resetMem(strdup(dirNam));
    case 65092 :
    case 65091 : 
	{
	const char *fn, *fn2;
	struct stat64 st;
	char *cmd, *cmds, *prg;
	FastBlock *fstblk = sw>65092 ? &fsels : &selAsSrc;
	int i=0, L, cn=fstblk->count();
	FastBlock lst(__AppenAlone);
	while( i<cn ){
		prg=addlst(fstblk->lstIndex(i++));
		lst.add(prg);
		free(prg);
		}
	lst.bufferString(32);		i=0;
	fn2=strrchr(fstblk->selchs(), '/');
	fn=catstr(dirNam, fn2, 0);
	fn2=catstr(fn, "ora", '.');
	if(stat64(fn2, &st)==0){
		if(isWritable(u_id, g_id, &st)){
			if(infoWidget(fn2, NULL, tarOverId, this))goto _jmp2_;
			}
		else {
			infoWidget(fn2, NULL, tarNoWriId, this);
	_jmp2_:		free((void *)fn2);
			goto _endcmpr_;
			}
		}

	fn=addlst(fn2);	free((void *)fn2);
	prg=catstr("mkar -f", oraEng[ar_engIdx], 32);
	cmd=catstr(prg, fn, 32);
	free(prg);	free((void *)fn);
	cmds=catstr(cmd, lst.buffer(), 32);
	free(cmd);
	comRun(NULL, cmds, 0, NULL);
	free(cmds);
	}
_endcmpr_: tPanel->showMsg(NULL);
	break;
    case 65090 :
    case 65089 : if(isViewOpera()==false)fsels.resetMem(strdup(dirNam));
    case 65088 : 
    case 65087 : {
	const char *fn, *fn2, *prg2;
	char *cmd, *cmds, *tmp, *prg;
	struct stat64 st;
	static const char arEng[3][10]={"bzip2 -cz", "gzip -c",  "lzma -cz" };
	FastBlock *fstblk = sw>65088 ? &fsels : &selAsSrc;
	int L, isDir=true, cn=fstblk->count();
	if(cn<2){
		fn=fstblk->lstIndex(0);
		stat64(fn, &st);
		isDir=S_ISDIR(st.st_mode);
		if(ar_engIdx>2 || isDir )goto _dir_;
		prg=addlst(fn);
		cmd=catstr(arEng[ar_engIdx], prg, 32);
		free(prg);
		cmds=catstr(cmd, ">", 32);
		free(cmd);
		tmp=catstr(dirNam, strrchr(fn, '/'), 0);
		fn2=catstr(tmp, ar_eng[ar_engIdx], 0);
		free(tmp);
		if(stat64(fn2, &st)==0){
		   if(isWritable(u_id, g_id, &st)){
			if(infoWidget(fn2, NULL, tarOverId, this))goto _jmp4_;
			}
		   else {
			infoWidget(fn2, NULL, tarNoWriId, this);
	_jmp4_:		free((void *)fn2);	free(cmds);
			goto _endcmpr_;
			}
		}
		prg2=addlst(fn2);
		free((void *)fn2);
		cmd=catstr(cmds, prg2, 32);
		free((void *)prg2);
		free(cmds);
		system( cmd );
		free(cmd);
		}
	else _dir_: {
	     static const char tarExtNam[arCnt][9]={ "tar.bz2", "tar.gz", "tar.lzma", "zip" },
		opts[arCnt-1][5]={ "-jcf",  "-zcf", "-Ycf" };
	     FastBlock lst(__AppenAlone);
	     prg2=strdup(fstblk->selchs());
	     tmp=strrchr((char *)prg2, '/');
	     L=tmp-prg2;
	     *tmp++=0;	/* L=strlen(prg2); */
	     while(i<cn){
		fn2=fstblk->lstIndex(i);
		fn=strrchr(fn2, '/')+1;
		if(memcmp(prg2, fn2, L) || fn2+L+1!=fn)fn=fn2;
		prg=addlst(fn);
		lst.add(prg);
		free(prg);	i++;
		}
	     lst.bufferString(32);
	     fn2=catstr(tmp, tarExtNam[ar_engIdx], '.');

	     if(ar_engIdx<3)cmds=catstr("tar --ignore-failed-read", opts[ar_engIdx], 32);
	     else cmds=(char *)( isDir ? "zip -y -r" : "zip -y");
	     fn=catstr(dirNam, fn2, '/');
	     free((void *)fn2);
	     if(stat64(fn, &st)==0){
		if(isWritable(u_id, g_id, &st)){
			if(infoWidget(fn, NULL, tarOverId, this)){
				if(ar_engIdx<3)goto _jmp1_;
				else goto _jmp5_;
				}
			}
		else {
			infoWidget(fn, NULL, tarNoWriId, this);
	_jmp1_:		free(cmds);
	_jmp5_:		free((void *)fn);	
			goto _endcmpr_;
			}
		}
	     fn2=addlst(fn);	free((void *)fn);
	     cmd=catstr(cmds, fn2, 32);
	     if(ar_engIdx<3)free(cmds);
	     free((void *)fn2);
	     cmds=catstr(cmd, lst.buffer(), 32);
	     free(cmd);
	     chdir(prg2);	free((void *)prg2);
	     system( cmds );
	     free(cmds);
	     chdir(pcwd);
	}
	}
	goto _endcmpr_;
case 65121 :   for(i=0; i<filesors.count(); i++)filesors.at(i)->cpLogAct->setEnabled(true);
	tPanel->showMsg(cpResultTip, 130, 1, 0x801512);
	break;
case 65119 :  cpThrPanel=new CopyPanel(bPanel); // (NULL, NULL,WX11BypassWM);
	cpThrPanel->execu(this);
	break;
case 65114  : // copy
case 65112 :  // move
	{ // isDir
	move_params *pm=(move_params *)e->data();
	int i=modeCvtIco(pm->dst);
	treeview->newDirItem(pm->dst, freqDPix(i), 0);
	free(pm->dst);
	if(sw==65112){
		treeview->testRemoveDir(pm->src);
		if(strcmp(pm->src, dirNam)==0) // Now currentItem not pm->src, and not selected, so ...
			treeview->setSelected(treeview->currentItem(), true);
	}
	free(pm->src);
	free(pm);
	}
	break;
case 65109 : { // cp over ?
	del_params *delpms=(del_params *)e->data();
	delpms->ret=_delFile(this, delpms->fn);
	delpms->hold=false;
	}
	break;
case 65107 : // copyFsEnd()
	if(panelStatus==1||panelStatus==2){
	    while(panelStatus==2)__sleep(600);
	    panelStatus=0;
	    delete cpThrPanel;
	}
	break;
case 65108 : {
	cpparam *pms=(cpparam *)e->data();
	pms->cpthr->countSize(pms->idx);
	free(pms);
	}
	break;
case 65130 : {
	char *info=copyInfo(copyMode, copyResult, cpSzM, copySize, take);
	bPanel->showMsg(info, 99);
	free(info);
	}
	break;
case 65201 :
	fsKillTimer();
	focusWdg=(QWidget *)e->data();
	focusWdg->raise();
	popWdgId=startTimer(12);
//case 65104 : PreCopyStats();
}

}
