/*
	Write by LinJiangHua (xempo) 9-14 2011
	Copyright LinJiangHua (xempo)
*/

#include <sys/errno.h>
#include <qcheckbox.h>
#include <qpainter.h>
#include <qtextcodec.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtooltip.h>
#include <qmetaobject.h>
#include <private/qucomextra_p.h>
#include "orlcon.h"
#include "Fophonix.h"
#include "infowidget.h"
#include "icon.def"
#include "ordir.h"

extern const char clickSig[];

#define IconSize  20

int msgboxSignal; // use in : void ListContent::contentsMousePressEvent( QMouseEvent* e )

int btnsLen(int btnCnt, const char **btnCap, const QFontMetrics &fmtr, const int *pix, bool isBtn)
{
int t, ln, len=0, fntSz=fontHeight, CRC=5*fntSz;
for(t=0; t<btnCnt; t++){
	ln=fmtr.size(Qt::SingleLine|Qt::ShowPrefix, QString::fromUtf8(btnCap[t])).width()+fntSz*2;
	if(pix&&pix[t]>-1)ln+=IconSize;
	if(isBtn&&ln<CRC)ln=CRC;
//	if(isBtn&&btnCnt<4&&ln<100)ln=100-(btnCnt-1)*(12-btnCnt); // let 2 big(longer) buuton show ...
	len+=ln;
	}
return len;
}

void createBtns(QWidget *wdg, QPushButton **Btn, const char **btnCap, int btnCount, int wd, int yPos, const char **slot1, const int *pix)
{
  QWidget *pwdg=wdg->topLevelWidget();
  int  fntSz=fontHeight,
  CRC=5*fntSz, t, k, tlen, len, elen;
  t=wd - btnsLen(btnCount, btnCap, pwdg->fontMetrics(), pix, true);
  if(t*100/wd>30){
	k=t/2;	k-=k%btnCount;
	elen=k/btnCount;
	if(elen>4*fntSz){
		elen=4*fntSz;
		k=elen*btnCount;
		}
	}
  else {
	k=0;
	elen=0;
	}
  tlen=(t-k)/2;  // 定按钮的起始, 修正??
  for(t=0; t<btnCount; t++){
	Btn[t]=new QPushButton(QString::fromUtf8(btnCap[t]), wdg);
	len=pwdg->fontMetrics().size(Qt::SingleLine|Qt::ShowPrefix, QString::fromUtf8(btnCap[t])).width()+fntSz*2;
	if(pix&&pix[t]>-1){
	      if(pix[t]<0x1000000){
		len+=IconSize;
		Btn[t]->setIconSet( *pixmapLoad(pix[t]) );
	      }
	      else Btn[t]->setPaletteForegroundColor(pix[t]&0xffffff);
	}
	if(len<CRC)len=CRC;
	len+=elen;
//	if(btnCount<4&&len<100)len=100-(btnCount-1)*(12-btnCount); // let 2 big(longer) buuton show ...
	Btn[t]->setGeometry( tlen,  yPos, len, fntSz*2 );
	pwdg->connect(Btn[t], clickSig, pwdg, slot1[t]);
	Btn[t]->setDefault(true);
	tlen+=len+4;
	}
}

struct info_wdg {
int infoType, pixId,
  btnCount, focus,
  color;
};

const char infoWdg_fsp[]="infoWidget",
	*slot_btn[7]={ SLOT(btn1()), SLOT(btn2()),SLOT(btn3()),SLOT(btn4()),SLOT(btn5()),SLOT(btn6()),SLOT(btn7()) };

InfoWidget::InfoWidget(QWidget *par) :
	QDialog(par, infoWdg_fsp, true,Qt::WStyle_NormalBorder),  color(0)
 // Qt::WType_TopLevel |Qt::WStyle_StaysOnTop	/*Qt::WStyle_Customize|Qt::WStyle_Title|*/
{
if(par){
	par->raise();
	par->setActiveWindow();
	setFont(par->font());
}
}

#define Info_field  6
int InfoWidget::infoExe(int Id, const char *txt_utf8, const char *cap)
{
static const char *cancelBtn="Cancel";
const char *tips, *wdgCap, **btnsCap,  *chs, *msgTxt=NULL;
char *ptr;
MAU mau[Info_field];
int btnCnt, *pix, hg, wd, t, n, len, txtlen, sh,
	fntSz=fontHeight;
struct info_wdg infowdg;
btnIndex=NO_BTN_ID;
msgboxSignal=0; // 禁pop对话框时，激活drag, 且是paintEvent中的标识
if(Id<0){
  infowdg.infoType=IW_ErrorInfo;
  pixmapId=-1;
  btnCnt=1;
  pix=NULL;
  infowdg.focus=0;
  btnsCap=&cancelBtn;
  wdgCap=Id!=-1 ? "Warn" : "RTL error";
  chs=txt_utf8;
  textLines=3;
}
else {
  __ORD *infowdgDir=_diropen(selfDir, infoWdg_fsp);
  if(infowdgDir==NULL)return NO_BTN_ID;
  if(numbRead(infowdgDir, Id, mau, Info_field, true)<0)return NO_BTN_ID;
//  ORDclose(infowdgDir, 2);
  memcpy(&infowdg, mau[0].buf, sizeof(info_wdg));
  pixmapId=infowdg.pixId;
  color=infowdg.color;
  wdgCap=mau[1].buf;
  msgTxt=mau[2].buf;
  btnCnt=infowdg.btnCount;
  btnsCap=(const char **)setargv(mau[3].buf, "\n", &btnCnt);
  pix=(int *)mau[4].buf;
  chs=txt_utf8 ? (msgTxt ? catstr( txt_utf8, msgTxt, '\n') : (char *)txt_utf8) : msgTxt;
  textLines=96;
}

  ptr=strdup(chs);
  infowdgText=setargv(ptr, "\n", &textLines);

 QPushButton *Btn[btnCnt];
 QCheckBox *ChkBox1;
 setCaption(QString::fromUtf8(cap? cap : wdgCap));

 microCRC=4;
 sh=fntSz+microCRC;
 hg=( 1+textLines + 1+3+1)*sh - (textLines>1 ? fntSz : fntSz/2);
 if(Id<0)wd=8*strlen(chs)+ 13*fntSz/2 ;
 else {
   len=0;
   for( t=0; t<textLines; t++ ){
	n=fontMetrics().size(Qt::SingleLine,QString::fromUtf8(infowdgText[t])).width();
	if(len<n)len=n;
	}
   txtlen=len+ 13* fntSz/2;
   if(txtlen>screenWidth-6)txtlen=screenWidth-6;
   len=btnsLen(btnCnt, btnsCap, fontMetrics(), pix, true);
   if(txtlen>len+60){
	if(txtlen+40>screenWidth)txtlen=screenWidth-40;
	wd=txtlen;
	}
   else wd=len+60;
 }
 if(wd<400)wd=400;

 switch(infowdg.infoType){
 case IW_SureDel : tips=noTipsMore;
	goto _chk_;
 case IW_CopyOver :  tips=overDeff;
	_chk_: hg+=2*fntSz;
	ChkBox1=new QCheckBox(QString::fromUtf8( tips), this); 
	ChkBox1->setGeometry( 80, (textLines+2)*sh, 300, fntSz*2 );
	ChkBox1->setChecked(infowdg.infoType!=IW_CopyOver ? false : pms_updateCopy);
	break;
 case IW_WarnOperaWrong : QApplication::beep();
 }
 setFixedSize(wd, hg);
 createBtns(this, Btn, btnsCap, btnCnt, wd, hg-fntSz*7/2, slot_btn, pix);

 Btn[infowdg.focus]->setFocus();
 QApplication::setOverrideCursor(QCursor(Qt::ArrowCursor)); // move file, when no right, pop dlg is moveCursor, so ...
 exec();
 QApplication::restoreOverrideCursor();
 free(infowdgText); free(ptr);
 if(Id>-1)free((void *)btnsCap);

 if(chs!=txt_utf8 && chs!=msgTxt)free((void *)chs);
 switch(infowdg.infoType){
 case IW_SureDel : __params[0]=ChkBox1->isChecked(); // cfg_warnDel
	break;
 case IW_CopyOver : pms_updateCopy=ChkBox1->isChecked();
 }
 return btnIndex;
}

bool InfoWidget::event( QEvent *e )
{
switch(e->type()){
case QEvent::Paint : {
	int  i, fntSz=fontHeight;
	QPainter painter(this);
	QPixmap *pix=pixmapLoad(pixmapId);
	painter.drawPixmap(fntSz, textLines>2 ? fntSz+pix->height()/2 : fntSz, *pix);
	//painter.setPen(color);
	setPaletteForegroundColor(color);
	for(i=0; i<textLines; i++)
	  drawText(80, (2+i)*(fntSz+microCRC) , QString::fromUtf8(infowdgText[i]) );//The y position is the base line position of the tex
	}
	return true;
}
return QDialog::event(e);
}

QMetaObject *InfoWidget::metaObj = 0;
static QMetaObjectCleanUp cleanUp_InfoWidget( infoWdg_fsp, &InfoWidget::staticMetaObject );
extern const QUMethod slot_0_0; // filesan.h
QMetaObject* InfoWidget::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{"btn1()", &slot_0_0,  QMetaData::Private },
	{"btn2()", &slot_0_0,  QMetaData::Private },
	{"btn3()", &slot_0_0,  QMetaData::Private },
	{"btn4()", &slot_0_0,  QMetaData::Private },
	{"btn5()", &slot_0_0,  QMetaData::Private },
	{"btn6()", &slot_0_0,  QMetaData::Private },
	{ "btn7()" , &slot_0_0, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(infoWdg_fsp, QDialog::staticMetaObject(), slot_tbl, 7,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_InfoWidget.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool InfoWidget::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool InfoWidget::qt_invoke( int _id, QUObject* _o )
{
int  sw=_id - staticMetaObject()->slotOffset();
switch(sw){
case 6 :
case 5 :
case 4 :
case 2 : 
case 3 : 
case 0 :  //_o[1].payload.i
case 1 :	btnIndex=sw;		close();
	break;
default : return QDialog::qt_invoke(_id, _o);
}
return true;
}

int infoWidget(const char *txt, const char *cap, int id, void *par)
{
InfoWidget wdg((QWidget *)par);
return wdg.infoExe( id, txt, cap);
}

int popInfo(const char *txt, const char *cap, int id, void *par)
{
switch(id){
// case -1 : is RTL
case -2 : return ErrorQuestion((QWidget *)par, normError, txt, cap );
case -3 : ((ORLcon *)par)->showInfo(txt, cap);
	return 0;
default : return infoWidget(txt, cap, id, par);
}
}

int ErrorQuestion(QWidget *wdg, int id, const char *filenam, const char *cap )
{
int rt;
char  *bu=catstr(strerror(errno), filenam, 32 );
rt=infoWidget(bu, cap, id, wdg );
free(bu);
return rt;
}

int postInfoWidget(QWidget *wdg, int num, const char *dst, int info_id, const char *cap)
{
  int rt;
  struct infowdg_params *overpms=(struct infowdg_params *)malloc(sizeof(struct infowdg_params));
  overpms->dst=dst;
  overpms->info_id=info_id;
  overpms->cap=cap;
  overpms->hold=true;
  appPost(num, overpms, wdg);
  while(overpms->hold)__sleep(300); // wait ...
  rt=overpms->ret;
  free(overpms);
  return rt;
}

void posterrInfo(QWidget *w, int num, const char *dst, const char *cap)
{// 不可挽回的错误，只能“取消”
char  *bu=catstr(strerror(errno), dst, 32 );
postInfoWidget(w, num, bu, normError, cap );
free(bu);
}

