/*
	Wrtie by xempo 2015
	Free under LGPL
*/

#include <qtoolbutton.h>
#include <qcursor.h>
#include "conspace.h"
#include "infor.h"
#include "dlist.h"
#include "jxswitch.h"
#include "ortime.h"
#include "write.h"
#include "shellcom.h"

#include "orlcon.h"
#include "filesan.h"
#include "../rtdata/en/target/filesor.h"

const QPixmap *_idPix;

void Filesan::ORLrightmenu(void *it, bool isView)
{
ActMenu menu(this), newORL(this), popMenu(this);
QPopupMenu cps(this);
menu.setFont(font());
newORL.setFont(font());
if(it){
	int i;
	if( selectDoneAct->isEnabled() ){
		selectDoneAct->addTo(&menu);
		selectAddAct->addTo(&menu);
		menu.insertSeparator();
	}
	if(copyAct->isEnabled()){
		copyAct->addTo(&menu);
		if(fdupAct->isEnabled()){ // is files
			for(i=0; i<3; i++)cps.insertItem( _engn[i], i );
			connect(&cps, sigactIdx, this, SLOT(ORLcps(int)) );
			menu.insertItem(QString::fromUtf8(cmprORL), &cps);
			menu.insertMenu(IdImg, writORL, this, SLOT(imagAs()), CTRL+Key_V);
		}
		menu.insertSeparator();
	}
	menu.insertMenu(delImg,  delIdChs, this, slot_del, Key_Delete);
	if(isView){
		menu.insertMenu(proEditImg, editIdChs, this, slot_proedit, Key_F6);
		menu.insertMenu(-1, chmodeChs, this, SLOT(chmod()), 0);
		menu.insertMenu(-1, chtimeChs, this, SLOT(chtim()), 0);
	}
	else {
		menu.insertMenu(attribImg, attribChs, treeview, SLOT(ORLattr()), CTRL+Key_D);
		menu.insertMenu(closeImg, closeORLChs, treeview, SLOT(closeORL()), 0);
	}
	menu.insertMenu(-1, renChs, this, slot_ren, Key_F2);
	menu.insertSeparator();
}
if(it||isView){
	newORL.insertMenu(newDirImg, new_DirChs, this, slot_newDir, CTRL+ALT+Key_N );
	newORL.insertMenu(newDirImg, newZDirChs, this, SLOT(newZDir()), ALT+Key_N );
	newORL.insertMenu(IdImg, newId, this, SLOT(new()), CTRL+Key_N );
	newORL.insertMenu(ORLspacImg, newORLChs, this, SLOT(newORL()), 0 );
	menu.insertItem(*pixmapLoad(newImg), QString::fromUtf8(newChs), &newORL);
}
if(isView==false){
	menu.insertSeparator();
	popMenu.lstCreatMenu(this, SLOT(openORL(int)), SLOT(clearORL()), ORLspacImg, &menuPlus);
	popMenu.insertMenu(orlZoneImg, orlconChs, this, SLOT(ORLcon()), 0);
	menu.insertItem(*pixmapLoad(ORoseImg), QString::fromUtf8(recentORLChs), &popMenu);
	}
menu.exec(QCursor::pos());
}

__ORL *lastWS()
{
int i;
for(i=SPACELIMIT-1; i>-1; i--)if(workspace[i])return workspace[i];
}

void Filesan::popORLcons(const char *fnam)
{
OpenSpace msg;
__ORL *lib;
if(orlZone&&orlZone!=(ORLcon *)this)orlZone->showTop();
else {
	orlZone=new ORLcon(this);
	orlZone->exe();
}
ORLtm=0;	lock=-1;
if(fnam&&fnam!=Fophonix){
	ORL_con=orlZone;
	lib=ORLspac(fnam, OpenSpace(RScript|CompactMsg|OpenLastDir), -1);
}
else lib=NULL;
if(cORL)cORL=testORL(cORL);
if(cORL==NULL&&modul==_OPENROSE){
	cORL=treeview->itemORLRoot((LVItem *)treeview->currentItem());
	treeview->setSelected(treeview->currentItem(), true);
	}
if(lib==NULL){
	if(cORL)lib=cORL;
	else lib=lastWS();
	}
treeview->setRecent(lib);
ORLtm=6;
orlZone->updateZone(lib);
if(fnam==Fophonix){
	strcpy(InpBuf, "workspace");
//	lock=-1;
	comRun(lib, InpBuf, 0, NULL);
	}
lock=0;
}

void Filesan::ORL_infor(__ORD *dir)
{
if(dir){
	char buf[300];
	ORLinfo(dir->lib, buf);
	tPanel->showMsg(buf, 0, 1, 0x4747a2);
	ORDinfo(dir, buf);
	bPanel->showMsg(buf, 0, 1, 0x135013);
}
}

void Filesan::IdSelects()
{
   LVItem *item=(LVItem *)_orllist->firstChild();
   Idsels.resetMem(NULL);
   while( item ){
	if( item->isSelected() )Idsels.add( item->fnam );
	item=(LVItem *)item->nextSibling();
      }
}

LVItem *Filesan::getItem(const char *txt)
{
   LVItem *item=(LVItem *)_orllist->firstChild();
   while( item ){
	if((strcmp(item->fnam, txt)|32)==32)return item;
	item=(LVItem *)item->nextSibling();
      }
   return NULL;
}

void Filesan::closeORlist()
{
ORoseBtn->setOn(false); 
tPanel->showMsg(NULL);
bPanel->showMsg(NULL);
pms_ORLview_h=_orllist->height();
delete _orllist;
//_orllist=NULL;
}

void Filesan::creatORLList()
{
const char **idCols=_filesor_+Int_IdCols1;
 int i, h;
 _orllist=new ListContent(mainSplit, ORLListChs, T_ORLList, this);
 _orllist->setSorting(-1);
 _orllist->setSelectionMode(QListView::Extended);
 _orllist->setRootIsDecorated(true);
 QValueList <int> szlst;
 i=mainBW->height();
 h=pms_ORLview_h ? pms_ORLview_h : i/3;
 szlst.append(i-h);
 szlst.append(h-2);
 mainSplit->setSizes(szlst);
 mainSplit->setResizeMode(_orllist, QSplitter::KeepSize);
 if(_idPix==NULL)_idPix=new QPixmap(*pixmapLoad(IdImg));
 idPix=_idPix;
 for(i=0; i<4; i++)
	_orllist->addColumn(QString::fromUtf8(idCols[i]));
 _orllist->setColumnAlignment(1, Qt::AlignRight);
 _orllist->show();
 for(i=0; i<ini_slot_cnt; i++)connect(_orllist, _filelistSig[i], this, _filelist_slots[i] );
// connect(vlst, sig_chcur, this, SLOT(test()) );  次序不同iconview，先currentChange
 connect(_orllist->header(), SIGNAL(clicked(int)), this, slot_sort );
 treeview->selectORD(); // select currentItem()
// setWdgSize( _orllist, ORLRoot, ORLviewId);
// _orllist->resize(mainBW->width(), h/3);
}

void Filesan::addNumb(__ORD *dir, BYTE *unit, bool SH/* show hide */)
{
static const char  dfmt[]="%d ",
	rwm[]="rwhoABGL"; // like dlist.c
int nmb=FCU_Numb(dir, unit);
BYTE mode;
if((*unit&3)==1 && (SH || ((mode=unit[1])&ORL_MH)==0) ){
	char buf[32];
	unsigned int L;
	DLong len=0;
	int  i,color;
	LVItem *sit=NULL, *it=(LVItem *)_orllist->firstChild();
	while(it&&it->nextSibling()){
		if(atoi(it->fnam)==nmb)return;
		it=(LVItem *)it->nextSibling();
	}
	if(it&&atoi(it->fnam)==nmb)return; // must do	
	sprintf(buf, dfmt, nmb);
	it=new LVItem(_orllist, it, buf);
	it->setPixmap(0, *idPix);
	if(mode&ORL_OEM)color=0x901313<<8;
	else {
		color=0;
		it->setRenameEnabled(2,true);
		if(mode&ORL_MW){
			it->setRenameEnabled(0, true);
			it->setRenameEnabled(3,true);
			if(mode&ORL_MR)color=0x000099<<8;
		}
		if((mode&ORL_MR)==0)color=0x106810<<8;
		}
	if(color)it->setType(color);
	for(i=0;i<dir->DAUC;i++){
		if( (L=(*unit>>2))==0 )
			L=*(unsigned int *)( pFcuDauPos( dir, unit, i )+sizeof(dskadr_t) + sizeof(unsigned int) );
		len+=L;
		if(dir->DAUC>1){
			sprintf(buf, dfmt, i);
			sit=new LVItem(it, sit, buf);
			sprintf(buf, "%u ", L);
			sit->setText(1, buf);
		}
	}

	sprintf(buf, "%llu ", len);
	it->setText(1, buf);
	L=paraExpre(unit[1], buf+1, rwm);
	*buf=32;	buf[L+1]=32; buf[L+2]=0;
	it->setText(2, buf);
	it->setText(3, ORasctim(FCU_GetDate(unit) ) );
	}
}

