/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011, 2012, 2014
  Free under LGPL
*/

#include "normal.h"
#include "jxswitch.h"
#include "options.h"
#include "ordir.h"
#include "dirext.h"
#include "dirloop.h"
#include "ortime.h"
#include "numbtype.h"
#include "write.h"
#include "read.h"
#include "fculoop.h"
#include "infor.h"
#include "conspace.h"
#include "stdfun.h"
#include "dlist.h"
#include "../../objcom/comm.h"

static int  arMsg;

static FILE *dirfp, *main_fp;

static const char *osMDir;

const char *releaChs[BrowsModeCnt]={ "-n", "-d", "-i", "-t", "-F" }, 
	*_releaChs[BrowsModeCnt]={ "--num", "--dir", "--include", "--total", "--force" };

#ifdef		_Single
static const char *dscpts[6]={
"#!	Main file of OpenRose exported project, 2005 ~ 2015\n",
"#!  RunTime-Lib export one dir's number as text, Format \n\
#!  NumbSet -m=<Mode>  -t=<Type>  -u=<dau>  -l=len1,len2...\n\
#!  -l    often use for exported by program,\n#!  use carefully(advise no use) by handwrite\n\
#!  Type   [C]har, [S]hort, [L]ong, [B]yte, [W]ORD, [D]WORD\n\n",
"#!		-- export at %s\n\n",
"\n\nimpcreat %s %s -u=%d -d=%d -n=%d\n\n",
"\nmkdir %s %s -m=%s -u=%d -d=%d -n=%d --cd\n",
"\nexe %s    #!\t\tOS-file\n"};
#else
static const char **dscpts;
#endif

static __ORD *inpdir;

static const char numbSet[]="\nnumbset %d -m=%s -t=%s %s\n",
	sysNumbSet[]="\nsysnumbset %d -m=%s -t=%s %s\n", rwMode[]="rwho";
/*
OEM-dir can't export, OEM-num can be export
*/

#define force  pagemore

BOOL readTo(__ORD *dir, BYTE *unit, int T, int n, FILE *fp)
{
  char *type, modebuf[8], typebuf[n+2];
  int len, j, udau, numb;
  MAU send[n];
  if(T){
	type=(char *)unit+FCU_TypePos(dir->Format);
	for(j=0; j<n; j++)typebuf[j]=TypeChr[type[j]];
  }
  else memset(typebuf, 'v', n);
  numb=FCU_Numb(dir, unit); /* must do it first , as zero*/
  if((udau=readFCU(dir, unit, send, n))<1)return False;
  char fmtstr[udau*6+20];
  typebuf[udau]=0;
  len=sprintf(fmtstr,"-u=%d -l=", udau);
  for(j=0; j<udau; j++)len+=sprintf(fmtstr+len, "%u,", send[j].len);
  fmtstr[len-1]=0;
  paraExpre(unit[1],modebuf, rwMode);
  fprintf(fp, dir->lib->sys_Id_done ? sysNumbSet : numbSet, numb, modebuf, typebuf, fmtstr);
  for(j=0; j<udau; j++){
	fwrite("{\n",2,1, fp);
	if(send[j].buf/*&&send[j].len>0*/){
		outCvt(send+j, T ? type[j] : (BYTE)_void);
		fwrite(send[j].buf,send[j].len,1, fp);
		free(send[j].buf);
	}
	fwrite("\n}\n", 3,1, fp);
      }
return True;
}

static int numExpo(__ORD *dir,BYTE *dsb)
{
  int Num_FCUs_Block, unitlen, n, T, i;
  __ORL *lib=dir->lib;
  if(lib->sys_Id_done){
	n=1;	Num_FCUs_Block=SYS_ID_BLOCK;
	T=0;	unitlen=FCU_NumPos+sizeof(DAU);
	}
  else {
	n=dir->DAUC;	Num_FCUs_Block=dir->Num_FCUs_Block;
	T=isType(dir->Format);	unitlen=dir->Num_FCU_Len;
	}

  for(i=0; i<Num_FCUs_Block; i++,dsb+=unitlen){
    if((*dsb&3)==1 && ( lib->sys_Id_done || canAccess(dsb[1]/*mode*/ ) /* can read & not hide */) ){
	if(arMsg){
		char  *dirnam=ORDpath(dir, inpdir, 2),
		*pth=catstr(osMDir, dirnam, '/');
		read_ar(dir, dsb, pth, 0 /*releadir*/, force|128);
		free(dirnam);	free(pth);
		}
	else readTo(dir, dsb, T, n, dirfp);
	}
  }
  return 1;
}

static int ORDexpo(__ORD *pcdir,__ORD *dir)
{
  static const char pStyle[4][6]={ "", "-z", "-t", "-z -t" };
  int idx=dir->Format&3;
  if(arMsg==0&&dirfp&&dirfp!=main_fp)fclose(dirfp);
  if(isNormDir(dir)){
    char  *dirnam=ORDpath(dir, inpdir, 2),
	*pth=catstr(osMDir, dirnam, '/');
    if(access(pth, 0)==0||mkdir(pth, 0755)==0){
        if(arMsg==0){
	char  modebuf[8], *rtlfile=catstr(pth, "runtime.rls", ROOT_CH);
	dirfp=fopen64(rtlfile, "wb");
	free(rtlfile);
	fwrite(dscpts[1],strlen(dscpts[1]),1,dirfp);
	paraExpre(dir->mode,modebuf, rwMode);
	fprintf(main_fp,dscpts[4], dirnam, pStyle[idx],
	modebuf, dir->DAUC,dir->Dir_FCUs_Block,dir->Num_FCUs_Block);
	fprintf(main_fp,"  \t#!\t%s", ORasctim(dir->datebuf));
	rtlfile=catstr(dirnam, "runtime.rls", ROOT_CH);
	fprintf(main_fp, dscpts[5], rtlfile);
	free(rtlfile);
	// if(pcdir)
	fwrite("cd *\n", 5, 1, main_fp);
	}
    }
    else {
	msgShow(pth);	ORtips(41,True);
	return 0;
	}
    free(dirnam); free(pth);
  }
  else if(arMsg==0){ // isRoot
	fprintf(main_fp,dscpts[3],dir->lib->fname, pStyle[idx],
		dir->DAUC,dir->lib->Dir_FCUs_Block,dir->lib->Num_FCUs_Block);
	dirfp=main_fp;
	}
  return 1;
}

void ORLexpo(__ORL *send,int n,char **pm, int isAr)
{
static const char self[]=".";
const char *_fnam;
int msg, brwVal[BrowsModeCnt];
memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
ProcOpt expOpt={
	BrowsModeCnt-1,
	browsMode, /*  { "-n", "-d", "-i", "-t", "-p" } */
	_browsMode,
	brwVal, 0, NULL, 0
	},
	releaOpt={
	BrowsModeCnt,
	releaChs, _releaChs,
	brwVal, 0, NULL, 0
	};
arglists *lst=procParas(n, pm, isAr ? &releaOpt : &expOpt, NULL);
__ORD *dir;
if(isAr&2){
	dir=(__ORD *)send;
	_fnam=lst->argv[0];
}
else {
	switch(lst->argc){
	case 0 : ORtips(58, True); /* such as:  export -n -d */
		showUsage(ORL_export);
		goto _exit_;
	case 1 : _fnam=self;
		break;
	default : _fnam=lst->argv[1];
	}
	dir=DirOpen(send->CurDir, (char *)lst->argv[0]);
}

if(idxdscpt>0x7ffd||(isAr&2)){
  char *pt;
  const char *fr=NULL, *os_dir;
  msg=getBM(brwVal);/* -F set pagemore, ==-p */
  if((msg&3)==0)
	msg=isAr ? 7 : 1;
  arMsg=isAr;
  inpdir=dir;
  if(_fnam==NULL){
	os_dir=self;	goto _skp_;
	}
  if(*_fnam=='~' && _fnam[1]=='/'){
	os_dir=catstr(getenv(homestr), _fnam+2, '/');
	fr=os_dir;
	}
  else os_dir=_fnam;

  if(access(os_dir,0)==0||mkdir(os_dir,0755)==0){
_skp_: if(arMsg)goto _jmp1_;
#ifndef  _Single
    if(dscpts==NULL){
	int cn=6;
	dscpts=(const char **)setargv(GetHB(32), "^", &cn);
    }
#endif
    { 	char buf2[2048];
	getcwd(buf2, 2047);
	pt=rstrrchr(os_dir[0]=='.'&&os_dir[1]==0? buf2:(char *)os_dir,ROOT_CH, ROOT_CH);
	pt=catstr(os_dir,pt,ROOT_CH);
    }
    _fnam=catstr(pt,RLS,0);	free(pt);
   if((main_fp=fopen64(_fnam,"wb"))!=NULL){
	BYTE buf1[16];
	fwrite(dscpts[0], strlen(dscpts[0]),1,main_fp);
	ORtime(0, buf1);
	fprintf(main_fp, dscpts[2], ORasctim(buf1));
	dirfp=main_fp;
_jmp1_:	osMDir=os_dir/*fullname(os_dir)*/;
	ORDexpo(NULL,dir);
	if(arMsg==0){
	    if(isRoot(dir)){
		fprintf(dirfp, "#! ________ NUMB_SYS_ID : ________\n");
		send->sys_Id_done=True;
		NumBrowth(dir, numExpo);
		fprintf(dirfp, "#! _______ NUMB_SYS_ID end _______\n\n");
	    }
	    ORDbrowth(dir,msg,numExpo,ORDexpo);
	    if(dirfp&&dirfp!=main_fp)fclose(dirfp);
	    fclose(main_fp);
	    msgShow("Export done !");
	}
	else ORDbrowth(dir,msg,numExpo,ORDexpo);
     }
     if(arMsg==0)free((void *)_fnam);
  }
  else ORtips(41,True);
  if(fr)free((void *)fr);
  ORDclose(dir,2);
}
else reportBug();
_exit_: argsFree(lst);
}

