/*
	Write & edit by Linjianghua(xempo) 2005-06,2008-2010,2011-2012, 2014
	Free under LGPL
	email: xempo@189.cn
*/

#ifndef    OpenRose_Lib
#define   OpenRose_Lib

#include "_devel.h"

#include <time.h>
#include <sys/stat.h>

#include "msgid.def"
#include "mau.h"
#include "datastru.h"

/* dir Style (Format) */
#define  ZeroMode		1

#define isZero(style)		(style&ZeroMode)
#define isType(style)		(style&2)
/* dir Style */

/* because 128 beyound all values, perhan numbstat's mode no exist, let it be 128 */
#define	LimitVal(n)		(n<1? 8:n)

#define prognamLen		3
#define blockSize			8
#define OrlTmLen			6

#define	ORL_DEL			(1<<4)
#define	ORL_REN			(2<<4)
#define	ORL_WRITE		(3<<4)
#define	ORL_READ		(4<<4)
#define	ORL_RESCUE		(5<<4)
#define	ORL_FCU_POS		(7<<4)
#define	ORL_FCU_BLANK		(8<<4)
#define	ORL_BROW		(9<<4) // 144

#define	NUMB_DEL		256+(1<<4)
#define	NUMB_REN		256+(2<<4)
#define	NUMB_WRITE		256+(3<<4)
#define	NUMB_READ		256+(4<<4)

#define	NUMB_RESCUE		256+(5<<4)
#define	NUMB_FCU_POS		256+(7<<4)
#define	NUMB_FCU_BLANK		256+(8<<4)
#define	NUMB_BROW		256+(9<<4)
#define	NUMB_LAST		256+(10<<4)
// (10<<4)=160

#define	ARCH_NORM		1024
#define	ARCH_BZIP2		2048
#define	ARCH_GZIP		4096
#define	ARCH_LZMA		8192


#define  fmt_CtrlSize  (blockSize-1)

#ifndef _NONE_FAST_PAGE_
typedef struct {
int NumbForZero; /* the FCT first numb */
dskadr_t pd_adr, pFCT;
}ZeroCache;

#endif

typedef struct {
dskadr_t addr;
unsigned int alen, // alloc len
len;  // use len
}DAU; /* Disk Alloc Unit */

/*   numb Formated Control Unit, like dir FCU DirFCU struct, '!' is persimsed user to ignore
tag 1
mode 1  // bit(set): 0 read, 1 write, 3 hide, 4 OEM;
time 6
numb
----------------
!  type[DAU]
.....
DAU ==> Disk Alloc Unit
*/
enum ORL_Mode { ORL_MR=1, ORL_MW=2, ORL_MH=4, ORL_OEM=8 };

typedef struct {
unsigned char tag, /* 0 init, 1 use, 2 be del, 3 erase( no rescue ) , above 2bit is SS len */
    mode,/* bit(set): 0 read,  1 write, 2 hide, 3 OEM 只能在开始写入，一经写入就固化 */
    datebuf[OrlTmLen]; /* re-write would 15 day late, Case  */
}baseFCU;
/* int numb */
#define	FCU_GetDate(fcu)		(fcu+2)
#define	FCU_TimePos		2
#define	FCU_NumPos		8

#define setDelTag( tag )  (tag=2|(tag & (255-1) ));
/* { (tag)&=255-1; (tag)|=2; } */

#define setErase( tag )   ((tag)|=3)


typedef struct {
  unsigned char tag,
    mode,/* bit(set): 0 read, 1 write, 2 hide, 3 OEM(8)
	4 ARCH_NORM; 5 ARCH_LZMA; 6 ARCH_GZ; 7 ARCH_BZIP2
	*/
    datebuf[OrlTmLen]; /* Case */
/* --------- baseFCU --------- */

#define DirNamLen       22
char  name[DirNamLen];
un_Int savelen;
#define  DIR_ADDR  32
dskadr_t pDir; // == dir->own_adr
}DirFCU; /* sizeof(...)=40, don't use BYTE for name */

#define	Dir_FCU_Len		sizeof(DirFCU)

/* follow use to __ORD */

typedef struct {
  dskadr_t  current_FCT,	/*  save for running */
  first_FCT;	/* 1st address  of block */
  BYTE FCU_Count, /* alloc dir-FCU every FCT(Disk-Space-Blank) */
  index;		/* index of func's tranfer, etc */
}FCU_PAT; /* FCUs Pre-Alloc Table */

typedef struct ORoseLib __ORL;

typedef struct { /*  __ORD  */
/****************  DirUnit:  *****************/
  __ORL *lib;
  void *pX; // such as FinaStock
  BYTE mdf, /* 1:modified;  4:first-FCT 8:CreatMsg for OEM numb; 128:use malloc */
#define   FIRST_FCT		4
#define   NEW_DIR			8
#define   FreeDirAlloc		64
  zcachesIndex, zSize,
  tmp1;/* root =>  sys_Id_done; */

  int NumbForZero;
  dskadr_t pos_numb_FCT; /* use story addr(pos) for seekFCU, so that other func */
   ZeroCache *zcache;
  _Int Num_FCU_Len,  otherOpen,
   tmp2, tmp3; /*  root => BYTE tmp2, ver1, ver2, ver3; */

/* __ORD include 2 part, part1 is Dir_FCU, part2 is DirUnit. */

 /* part1 ----------- DirFCU struct ----------- */
  BYTE tag, mode, datebuf[OrlTmLen];
  char name[DirNamLen];
  un_Int savelen;
  dskadr_t own_adr;            /* ptr(dsk) this black */
 /* ------------ image DirFCU end ------------- */

/* part2 +++++++++++++++ disk save begin ++++++++++++++++++++++++ */ 
/* ___________ numb's FCU_PAT ___________ */
  dskadr_t cur_numb_FCT,         /* current numb's FCT */
  numb_FCT;		   /* this dir's numb-style address */
  BYTE Num_FCUs_Block,		/* alloc FCUs every FCT */
  dIdx; /* use in bsearch */
/* __________ end numb's FCT __________ */
  un_Int Format;/* idx lenght-style, its numb-style */
  unsigned int selfnumbs;

/* __________ dir's FCU_PAT __________ */
  dskadr_t next_dir_FCT,		/* next_csb, save for libfnd */
  dir_FCT;         /* this dir's dir-style address */
  BYTE  Dir_FCUs_Block, /* alloc dir-FCUs every FCT(Disk-Space-Blank) */
  dir_idx;		/* reserve for compact */
/* _________ end dir's FCT ________ */
  un_Int DAUC; /* can be 7256 dau, as 7256*9+31=65335, use 5000, this is a cells format CVT
  	 in the future */
  unsigned int selfdirs;	        /* total count of Numb */

  DLong  selfsize;
  dskadr_t parent_adr,
/*******************  DirUnit  *****************/

  Own_FCU_Addr;		/* ptr(dsk) this dir's FCU */
/* ++++++++++++++++ end disk-storage ! DON'T change pos ++++++++++++++++ */
#define  DIR_SAV_SIZ  72    /* 24+24+24=72 */

}__ORD;

struct ORoseLib {
/*********************  DirUnit:  ******************/
  __ORL *lib;
  void *pX; // orlTree
  BYTE mdf, /* 1:modified;  4:first-FCT 8:CreatMsg for OEM numb; (16:use malloc[dir])
	128: changed, butno chtime 
	 */
#define  OnlyChDir  128
  zcachesIndex, zSize,
  sys_Id_done;
  int NumbForZero;
  dskadr_t pos_numb_FCT; /* use story addr(pos) for seekFCU, so that flash FCT */
   ZeroCache *zcache;
  _Int Num_FCU_Len,
  openMode; /*  #define  OpenAlway  64, can't close, like attrib, must set 0 special  */
  BYTE openIdx,
	ver1, ver2, ver3;
/* __ORD include 2 part, one is dir_FCU(like DirFCU), one is dirsOld(DirUnit). 2 opera for 2 part also. */

/* ++++++++++++++++++++ disk begin ++++++++++++++++++++ */
/* ===== Compact DirFCU, like dir's DirFCU image ===== */
  BYTE CtrlSiz, mode, datebuf[OrlTmLen];
  char name[2]; /*org=[DirNamLen]  22, follow remain 20 byte be use any*/
  unsigned short CmprSiz;
  unsigned int tolDir;
  DLong  tolNumb,  useSize;
  dskadr_t own_adr; /* this must use, as is tag   2016-3-26*/
/* ==== above like DirFCU (40byte) ==== */

/* ------numb's FCU_PAT ------- */
  dskadr_t cur_numb_FCT,  numb_FCT;
  BYTE Num_FCUs_Block,
  dIdx; /* bsearch */
/* -------- end numb's FCT -------- */
  un_Int Format;
  unsigned int selfnumbs; /* self dir's numb count */
  
/* ----- dir FCU_PAT -------*/
  dskadr_t DefaultDir, dir_FCT;
  BYTE Dir_FCUs_Block,
  dir_idx; /* no use */
/* -------- end FCT ------- */
  un_Int DAUC;
  unsigned int selfdirs;
  
  DLong selfsize;
  dskadr_t parent_adr;
/* ***************  DirUnit  len=104( 40+24+24+16 ) ***************/

/* ----- sys numb FCU_PAT, NUMB_SYS_ID  ----- */
  dskadr_t cur_sys_numb_FCT,  sys_numb_FCT;
  BYTE SysNum_FCUs_Block, sys_id_idx,
#define	SYS_ID_BLOCK	5
/* -------- end FCT -------- */
  cmprPer, res1;
/* +++++++++++++++++ disk end ++++++++++++++++++ */
#define	CTRLSIZE		(104+20)
  int FCT_calc; /* here compact  64bit   104+ 20+4 */

  DLong fsz;
  dskadr_t FCU_dyw, // dy for every pos to writedisk
  bakdir_adr,
  LNKDWORD;

  __ORD *CurDir;
  void *xParent; // such as: filesor
  const char *fname;
  FILE *fpt;

/* opened dirs ctrls, 3 member */
  __ORD **usedirs;
  int cnt_usedir, pre_usedir; /* for usedirs which opening dirs */
/* end open dirs ctrls */
  int openTimes, /* mult open */
	x_msg;/* use X program */
};

/*-------- self Id --------*/
#define SCRIPT_ID		1
#define PATH_ID		2
#define CONFIG_ID		3
#define AUTORUN_ID		4
// #define SYS_ID_BLOCK	5
/* normal only 0,1 as spec */

#define  cleanDirMdf(dir) (dir->mdf&=NEW_DIR|FreeDirAlloc)

#define dGetFCU(dir) ((FCU_PAT *)&dir->next_dir_FCT)
#define nGetFCU(dir) ((FCU_PAT *)&dir->cur_numb_FCT)
#define sys_nGetFCU(fs) ((FCU_PAT *)&fs->cur_sys_numb_FCT)

#define  FCU_DAUPos(dir,sw)  (dir->Num_FCU_Len - sizeof(DAU)*(dir->DAUC-sw) )

#define  FCU_TypePos(style)  (isZero(style) ? FCU_NumPos : FCU_NumPos+sizeof(int))	

#define  pFcuDauPos(dir, fcu, sw)  (fcu+( dir->lib->sys_Id_done? FCU_NumPos : FCU_DAUPos(dir,sw) ))

#define  FCU_Numb(dir, fcu)  (dir->lib->sys_Id_done||isZero(dir->Format) ? dir->NumbForZero++ : *(int *)(fcu+FCU_NumPos))

extern const char orlKern[];

extern int idxdscpt; /* normal set 0x7fff, 0x7ffe is write disk successful tag, other error No. */
extern __ORL *LibCmpr;

#define noWrite( mode )		((mode&ORL_MW)==0 || (mode&ORL_OEM))
#define canWrite( mode )		((mode&ORL_MW) && (mode&ORL_OEM)==0)
#define canRead( mode )		(mode&ORL_MR)
#define canAccess( mode )		( (mode&ORL_MR) && (mode&ORL_MH)==0 )

#define isRoot(dir)		(dir->parent_adr==1)
#define isNormDir(dir)		(dir->parent_adr!=1)

#define namecpy(dst,src)  memcpy(dst,src,DirNamLen-1)

extern void FailSeekMsg(int msg);
extern void creatFCT(__ORD *dir, int len, int n);
extern void appFCT(__ORD *dir, const void *dat, int len);

__BEGIN_DECLS
extern void *zalloc(unsigned int sz);
#define MAUalloc(cn)	(MAU *)zalloc(cn*sizeof(MAU))

extern void freeMAU(MAU *pm, int n);

extern void ORtime(time_t ti/* =0  is current*/, BYTE *b_ddtt);

extern int readFCU(__ORD *dir,BYTE *stat,MAU *send,int n);
extern BYTE *NumRead(__ORD *dir,int numb,MAU *send,int n);
extern BYTE *NumWrite(__ORD *dir,int numb,MAU *send,int n);

extern BYTE *seekFCU(__ORD *dir,int numb, const void *dirnam, int msg);
#define ORDseek(dir,dirnam,msg)	(DirFCU *)seekFCU(dir,0,dirnam,msg)
#define NumSeek(dir,nmb,msg)	seekFCU(dir,nmb,NULL,msg)

extern int NumLast(__ORD *dir); // zero append

extern BOOL NumDel(__ORD *dir,int numb);
extern BOOL NumRen(__ORD *dir,int oldnmb,int newnmb);

__END_DECLS

extern void dkwrite(__ORL *, dskadr_t pos, const void *dat, unsigned int len);
extern unsigned int dkread(__ORL *uxb, dskadr_t pos,void *dat, unsigned int len, unsigned int cn);

extern void setFCU(__ORD *dir,int step);

extern dskadr_t *getDAU(__ORD *dir,BYTE *stat, unsigned int *alen, unsigned int *len, int idx);

extern char *readDAU(__ORD *dir,BYTE *stat, MAU *send,int idx);
/* return send->buf */

extern void addFCT(__ORD *dir,BYTE *stat);
extern void writeFCU(__ORD *dir,BYTE *statbuf, time_t tm);

extern void writeDAU(__ORD *dir, BYTE *stat, MAU *send, int idx);
extern BYTE *writeInit(__ORD *dir,int numb,MAU *send,int n);

/*________________________________________________*/

extern void ORDsave(__ORD *dir);

#define  getSize(dir, fcu, Len) {  int i, dau=dir->DAUC; \
  if(dau==1 && *fcu>3)Len=*fcu>>2; \
  else { \
	Len=0; \
	for(i=0;i<dir->DAUC;i++)Len+=*(unsigned int *)( pFcuDauPos( dir, fcu, i )+sizeof(dskadr_t) + sizeof(unsigned int) ); \
	} \
  }

#define setAlenDAU(daupos, len)  *(unsigned int *)(daupos+sizeof(dskadr_t))=len
#define setLenDAU(daupos, len)  *(unsigned int *)(daupos+sizeof(dskadr_t)+sizeof(unsigned int))=len

extern void DFCUmdf(__ORD *dir, BYTE *fcu, dskadr_t pos, int step);


#endif

